(*$DEFINE NODEBUG *)

(*$IFDEF VER40 *)

  (*$IFDEF DEBUG *)
    {$R-,S+,I+,D+,T-,F-,V+,B-,N-,L+ }
    {$M 16384,0,655360 }
  (*$ELSE *)
    {$R-,S-,I-,D-,T-,F-,V-,B-,N-,L+ }
    {$M 16384,0,655360 }
  (*$ENDIF *)

(*$ELSE *)

  {$A-,B-,D+,E-,F-,I-,L+,N-,O-,R-,S-,V- }
  {$M 16384,0,655360 }

(*$ENDIF *)

program CopTel;
uses Dos,Crt,KeySys,RsSys,VideoSys,SerTools,Stringer,Error,InterSpc;

const SOFTNAME  = 'COPTEL';
      VERSION   = 'V1.3';
      DATEVER   = '30/05/90';
      AUTEUR    = 'T.JAOUEN';
      COPYRIGHT = 'SIXIEME CONTINENT';

const NbreFields = 16;
      Field : array[1..NbreFields] of Space_map = (
(X: 79; Y: 24; Lg: 1; Ht: 1), (* joker : 1 *)
(* wind error *)
(X: 21; Y: 6; Lg: 9; Ht: 1), (* abandon : 2 *)
(X: 50; Y: 6; Lg: 9; Ht: 1), (* reprise : 3 *)
(X: 0), (* : 4 *)
(* menu *)
(X: 28; Y: 5; Lg: 24; Ht: 1), (* emission : 5 *)
(X: 28; Y: 6; Lg: 24; Ht: 1), (* reception : 6 *)
(X: 0), (* : 7 *)
(X: 0), (* : 8 *)
(X: 0), (* : 9 *)
(X: 0), (* : 10 *)
(X: 0), (* : 11 *)
(X: 0), (* : 12 *)
(* YesOrNo *)
(X: 21; Y: 12; Lg: 7; Ht: 1), (* Non : 13 *)
(X: 52; Y: 12; Lg: 7; Ht: 1), (* Oui : 14 *)
(X: 0), (* : 15 *)
(X: 0; Y:0; Lg: 0; Ht: 0) ); (* NbreFields *)

(*******************************************************)
(*                                                     *)
(*                        PARAM                        *)
(*                                                     *)
(*******************************************************)

type TypeParam = string[12];
     CFG_map  = record
                  VFixe  : boolean;  { TRUE=> le mode video a t fix }
                  CGA    : boolean;
                  NEIGE  : boolean;
                  IRQ    : byte;
                  ADR    : word;
                  LgIN   : word;
                  LgOUT  : word;
                end;

const CFG      : CFG_map = (
                  VFixe  : FALSE;
                  CGA    : true;
                  NEIGE  : false;
                  IRQ    : 4;
                  ADR    : 0;    (* adresse indfinie *)
                  LgIN   : 1024;
                  LgOUT  : 0
                    );
      CFGFileName = 'COPTEL.CFG';
      NbreParam = 13;
      ParamTab : array[1..NbreParam] of TypeParam =
                   ('CGA','MDA','NEIGE','PASNEIGE',
                    'COM1','COM2','COM3','COM4','LGIN','LGOUT',
                    'VER',
                    'IRQ3','IRQ4' );

procedure Hex(texte : string; var nb : word; var code : integer);
var val : word;
    index : byte;
begin
  val  := 0;
  for index := 1 to length(texte) do
    if texte[index] in ['0'..'9'] then
      val := (val*16)+(byte(texte[index])-48)
    else
      if texte[index] in ['A'..'F'] then
        val := (val*16)+(byte(texte[index])-55)
      else
        begin
          code := index;
          exit;
        end;
  code := 0;
  nb := val;
end;

function TradNumber(texte : string; var nb : word) : boolean;
var code : integer;
    save : word;
begin
  if texte<>'' then
    if texte[1]='$' then Hex(copy(texte,2,length(texte)-1),nb,code)
    else
      begin
        save := nb;
        Val(texte,nb,code);
        if code<>0 then nb := save;
      end;
  TradNumber := (code=0);
end;

procedure GestParam;
var ParamLine : string;
  procedure ChargeParam;
  var fichier : file of byte;
      io : word;
      index : byte;
      colector : byte;
  begin
    ParamLine := '';
    assign(fichier,CFGFileName);
    (*$I-*)
    reset(fichier);
    io := ioresult;
    if io=0 then
      begin
        index := 1;
        while not(eof(fichier)) and (index<256) and (io=0) do
          begin
            read(fichier,colector);
            io := ioresult;
            if colector<48 then colector := byte('/');
            ParamLine := ParamLine+char(colector);
          end;
        if (io=0) then close(fichier);
      end;
    if (io<>2) and (io<>0) then
      begin
        writeln('Erreur lors du chargement du fichier '+CFGFileName);
        writeln('Erreur: ',MsgError(io));
        halt(1);
      end;
    (*$IFDEF DEBUG *) (*$I+*) (*$ENDIF *)
  end;

const com : byte = 1;
var index : byte;
    code  : integer;
    CurrentParam : string;
    SecondStr : string;
    Good : boolean;
    ForceEnd : boolean;
begin
  ParamLine := '';
  ChargeParam;
  ParamLine := ParamLine+' ';
  for index := 1 to ParamCount do
    ParamLine := ParamLine+ParamStr(index)+' ';
  ForceEnd := false;
  repeat
    index := 1;
    while(index<=length(ParamLine)) and
         not(ParamLine[index] in [' ','+',',','/']) do Inc(index);
    CurrentParam := copy(ParamLine,1,index-1);
    ParamLine := copy(ParamLine,index+1,length(ParamLine)-index);
    KillData(CurrentParam,32);
    UpCaseStr(CurrentParam);
    index := Pos('=',CurrentParam);
    if index<>0 then
      begin
        SecondStr := copy(CurrentParam,index+1,length(CurrentParam)-index);
        CurrentParam := copy(CurrentParam,1,index-1);
      end
    else
      SecondStr := '';
    Good := false;
    for index := 1 to NbreParam do
      if CurrentParam = ParamTab[index] then
        begin
          Good := true;
          case index of
            1 : begin (* CGA *)
                  CFG.VFixe := TRUE;
                  CFG.CGA := true;
                  CFG.Neige := false;
                end;
            2 : begin (* MDA *)
                  CFG.VFixe := TRUE;
                  CFG.CGA := false;
                  CFG.Neige := false;
                end;
            3 : CFG.Neige := true; (* NEIGE *)
            4 : CFG.Neige := false; (* PASNEIGE *)
            5 : begin (* COM1 *)
                  CFG.Irq := 4;
                  com     := 1;
                end;
            6 : begin (* COM2 *)
                  CFG.Irq := 3;
                  com     := 2;
                end;
            7 : begin (* COM3 *)
                  CFG.Irq := 4;
                  com     := 3;
                end;
            8 : begin (* COM4 *)
                  CFG.Irq := 3;
                  com     := 4;
                end;
            9 : begin (* LGIN= *)
                  Good := TradNumber(SecondStr,CFG.LgIn);
                end;
           10 : begin (* LGOUT= *)
                  Good := TradNumber(SecondStr,CFG.LgOut);
                end;
           11 : begin (* VER *)
                  writeln(SOFTNAME,' ',VERSION,' ',DATEVER);
                  writeln('par ',AUTEUR,'  copyright ',COPYRIGHT);
                  writeln('Ce logiciel a t mis dans le domaine public.');
                  writeln('Il ne peut pas faire l''objet d''une transaction commerciale.');
                  writeln('Il peut tre copi et utilis sans restriction.');
                  ForceEnd := true;
                end;
           12 : CFG.Irq := 3; (* IRQ3 *)
           13 : CFG.Irq := 4; (* IRQ4 *)
          end; (* case of *)
        end;
    if not(Good) and (CurrentParam<>'') then
      begin
        write('paramtre incorrecte -> ''',CurrentParam);
        if SecondStr<>'' then write('=',SecondStr);
        writeln('''');
        ForceEnd := true;
      end;
  until ParamLine='';
  if ForceEnd then halt(0);
  CFG.Adr := memw[$40:$00+(com-1)*2];
  if CFG.Adr=0 then
    begin
    writeln('Carte srie absente');
    halt(1);
    end;
end;

(********************************************)
(*                                          *)
(*                  RS232                   *)
(*                                          *)
(********************************************)

const
      MPRO1 = #27#$39;
      MPRO2 = #27#$3A;
      MPRO3 = #27#$3B;
      MOFF  = #$60;
      MON   = #$61;
      MSTART = #$69;
      MSTOP  = #$6A;
      MROULEAU = #$43;
      MEEcran = #$50; (* module emeteur code *)
      MEClavier = #$51;
      MEModem = #$52;
      MEPrise = #$53;
      MREcran = #$58; (* module recepteur code *)
      MRClavier = #$59;
      MRModem = #$5A;
      MRPrise = #$5B;

      Porteuse      = '!"#$%&';
      ImReady       = '->*';
      Bourratif     = #0#0#0#0#0#0#0#0;
      SOk           = '*=#'#10#13;
      SRep          = '#!?'#10#13;
      SNon          = '<#>'#10#13;
      SFin          = '>!<'#10#13;
      NewLine       = #10#13;

      MxEssaiPaquet = 3; (* envoi de paquet maximun! *)
      TypeTransfert = 0; (* associer comme Word a l'envoi de la longueur *)

      LgTrieFilt = 1;
      TrieFilt : array[1..LgTrieFilt,1..2] of byte = ( (64,127) );
      LgPathos = 5;
      FOk  = 1; (* code en retour d'un FindPath *)
      FRep = 2;
      FNon = 3;
      FFin = 4;
      FNL  = 5; (* remarque: Code de derniere priorite *)
      Pathos : array[1..LgPathos] of StringPath =
                 (SOk,SRep,SNon,SFin,NewLine);

procedure WriteCom(texte : string);
var index : byte;
begin
  for index := 1 to length(texte) do PutData(ShortInt(texte[index]));
end;

const  Speed75   = 0;
       Speed300  = 1;
       Speed1200 = 2;
       Speed4800 = 3;
       Speed9600 = 4;

type SpeedRec = record
         ToSpeed : string[4];
         BD      : word;
         DTS     : word;      { (delay) temps d'attente apres ToSpeed }
         TS      : byte;      { temps sommeil }
       end;

const NbSpeed = 5;
      TabSpeed : array[0..NbSpeed-1] of SpeedRec = (
  ( ToSpeed:MPRO2+char($6B)+char(64+9);  BD:BD75;   DTS:768; TS:5 ),
  ( ToSpeed:MPRO2+char($6B)+char(64+18); BD:BD300;  DTS:192; TS:3 ),
  ( ToSpeed:MPRO2+char($6B)+char(64+36); BD:BD1200; DTS:48;  TS:3 ),
  ( ToSpeed:MPRO2+char($6B)+char(64+54); BD:BD4800; DTS:12;  TS:2 ),
  ( ToSpeed:MPRO2+char($6B)+char(64+63); BD:BD9600; DTS:3;   TS:2 )
       );
      LastSpeed : byte = 255;

procedure RestoreMinitelSpeed;
var bidon : char;
begin
  if LastSpeed<>255 then
    begin
      ClearCom;
      repeat until OutEmpty;
      WriteCom(#0#0+                       { prepare le terrain... }
               MPRO1+char($7F)+            (* reset *)
               MPRO3+MON+MREcran+MEPrise+  (* Prise   -> Ecran *)
               { MPRO3+MON+MREcran+MEClavier+ } (* Clavier -> Ecran *)
               MPRO3+MON+MRPrise+MEClavier); (* Clavier -> Prise *)
      repeat until OutEmpty;
      delay(100);
      while CharIn do bidon := GetCom; (* vide le buffer recep *)
      WriteCom(TabSpeed[LastSpeed].ToSpeed);
      repeat until OutEmpty;
      delay(TabSpeed[LastSpeed].DTS);  { attend }
    end;
end;

function MinitelIsHere : boolean;
(* s'assure de l'existence d'un minitel en envoyant une demande de *)
(* position de curseur *)
(* 1' essai a 1200 bauds *)
(* 2' essai a 4800 bauds : force vitesse a 1200 et recommence 1 *)
(* 3' essai a 300 bauds : force vitesse a 1200 et recommence 1 *)
(* 4' fin *)
const To1200BD    = #27#$3A#$6B#100; (* reclamme x bauds->1200 bauds *)
      StatutOk    = #27#59#$63#$5B#255;  { #31#65#65; }
      ClaimStatut = #0#12#27#58#$62#$5B; { #31#65#65#27#$61; }
      OrderRank : array[0..NbSpeed-1] of byte =
        (Speed1200,Speed4800,Speed9600,Speed300,Speed75);
var Essai : byte;
    Good  : boolean;
    SpeedC : byte;
begin
{  SleepTime    := 3;
  GlobalTime   := 3; }
  UserKey      := #0;
  DualActivity := FALSE;
  SetFilter(Essai,0,Essai,0,Essai,0); (* bidon *)
  Essai := 0;
  Good  := false;
  while (Essai<NbSpeed) and not(Good) do
    begin
      SpeedC := OrderRank[Essai];
      ChangeParams(TabSpeed[SpeedC].BD,EVEN+BITS7+STOP1);
      WriteCom(#0#0+To1200BD); (* force le passage en 1200 bauds *)
      repeat until OutEmpty;
      delay(50);
      ChangeParams(BD1200,EVEN+BITS7+STOP1);
      WriteCom(ClaimStatut);  (* demande de position de curseur *)
      SleepTime    := TabSpeed[SpeedC].TS;
      GlobalTime   := SleepTime;
      if GetPath(StatutOk)>0 then
        begin
          Good  := true; (* on attend la position *)
          LastSpeed := SpeedC;
        end
      else Inc(Essai);
    end;
  MinitelIsHere := Good;
end;

(********************************************)
(*                                          *)
(*                  VIDEO                   *)
(*                                          *)
(********************************************)

function EscKey : boolean;
begin
  EscKey := not(Funct) and (Key=#27);
end;

procedure DessWind(X,Y,Lg,Ht : byte);
begin
  ClrZone(X,Y,X+Lg-1,Y+Ht-1,CNorm);
  MakeCadre(X,Y,X+Lg-1,Y+Ht-1,CNorm);
end;

procedure CreateWind(X,Y,Lg,Ht : byte);
begin
  EmpileWind(X,Y,X+Lg-1,Y+Ht-1);
  DessWind(X,Y,Lg,Ht);
end;

procedure WriteChoix(texte : string; x,y : byte);
begin
  WriteScr(texte,CNorm,x,y);
  MakeCadre(x-1,y-1,x+length(texte),y+1,CNorm);
end;

procedure InviteKey(x,y,Lg : byte);
begin
  WriteScr(CentreString('Appuyer une touche pour continuer',Lg,32),CInv,x,y);
  GetKey;
end;

procedure ChsStr(texte : string; NmBlk,NmSpace : byte);
begin
  if Block[NmBlk].NbSpc<Block[NmBlk].MxNbSpc then
    begin
      ChsSpc(NmBlk,NmSpace);
      WriteScr(CentreString(texte,Field[NmSPace].Lg,32),CNorm,
               Field[NmSpace].X,Field[NmSpace].Y);
    end;
end;

const NoMinitel    = 256;
      EmptyFile    = 257;
      E_NoMoreTime = 258;
      E_TooLate    = 259;
      E_UserAction = 260;
      E_FFin       = 261;
      E_FNon       = 262;

function MsgError(io : word) : string;
begin
  if io<256 then MsgError := Error.MsgError(io)
  else
    case io of
      NoMinitel   : MsgError := 'LIEN NON ETABLI AVEC LE MINITEL';
      EmptyFile   : MsgError := 'FICHIER VIDE INTRANSMISSIBLE';
      E_NoMoreTime: MsgError := 'TEMPS IMPARTI DEPASSE';
      E_TooLate   : MsgError := 'INACTIVITE ANORMALE';
      E_UserAction: MsgError := 'APPUIE SUR [Esc]';
      E_FFin      : MsgError := 'DETECTION DU SIGNAL D''ABANDON';
      E_FNon      : MsgError := 'COMMUNICATION NON PROTOCOLAIRE';
    else MsgError := 'ERREUR NON DEFINIE';
    end;
end;

const Abandon = 0;
      Reprise = 1;
      NoError = 2;

function WindError(io : word; choix : boolean) : byte;
(* choix = FALSE -> on demande juste d'appuyer une touche *)
(* choix = TRUE  -> on attend soit Reprise, soit Abandon  *)
const X = 18; Y = 0; Lg = 44; Ht = 9;
      Titre = ' ERREUR ';
var Result : byte;
    index  : byte;
    EndBoucle : boolean;
begin
  if io<>0 then
    begin
      CreateWind(X,Y,Lg,Ht);
      WriteScr(titre,CInv,x+CentralPos(length(titre),Lg-2),y+1);
      WriteScr(CentreString(MsgError(io),Lg-2,32),CSurI,X+1,Y+3);
      if choix then
        begin
          EmpileBlk;
          WriteChoix(' ABANDON ',Field[2].X,Field[2].Y);
          WriteChoix(' REPRISE ',Field[3].X,Field[3].Y);
          OneBlock(2,2,false,false);
          for index := 2 to 3 do ChsSpc(NbBlk,index);
          SelectSpc := Reprise+1;
          SelectBlk := 1;
          EndBoucle := false;
          repeat
            if interaction then
              begin
                Result := SelectSpc-1;
                EndBoucle := true;
              end;
          until EndBoucle;
          DepileBlk;
        end
      else
        begin
          InviteKey(X+1,Y+Ht-2,Lg-2);
          Result := Abandon;
        end;
      DepileWind;
      WindError := Result;
    end
  else WindError := NoError; (* car io n'est pas une erreur *)
end;

var LastVideoMode : byte;

procedure EndSoft;
begin
  RestoreMinitelSpeed; { si LastSpeed<>255 }
  CloseRsSys;
  CloseCom;
  CloseVideoSys;
  SetVideoMode(LastVideoMode);
  CloseInteraction;
  halt(0);
end;

procedure InitSoft;
var AdrEcran : pointer;
begin
  (*$IFNDEF DEBUG *)
  CheckBreak := FALSE;
  (*$ENDIF *)
  CInUse := CInv;
  COnSpc := CInv;
  OpenInteraction(Field,NbreFields);
  LastVideoMode := VideoMode;
  if not(CFG.VFixe) then CFG.CGA := VideoCarte<>3;
  if CFG.CGA then
    begin
      AdrEcran := ptr($B800,$0000);
      SetVideoMode(C80);
    end
  else
    begin
      CFG.Neige := FALSE;
      AdrEcran := ptr($B000,$0000);
      SetVideoMode(Mono);
    end;
  OpenVideoSys(AdrEcran,CFG.Neige);

  if CFG.LgIn<128 then CFG.LgIn := 0;
  if CFG.LgOut<128 then CFG.LgOut := 0;
  OpenCom(CFG.Irq,CFG.Adr,BD1200,EVEN+BITS7+STOP1,CFG.LgIn,CFG.LgOut,
          TRUE,TRUE);

  ClrZone(0,0,79,24,CNorm);
  DessWind(0,0,80,3);
  WriteScr(CentreString(SOFTNAME+' '+VERSION+'  par '+AUTEUR+' copyright '+COPYRIGHT,
            78,32),CInv,1,1);
  OpenRsSys(0,15,80,10);
  EmulOut := true;
  EmulLineDeb := true;
  while not(MinitelIsHere) do
    if Abandon = WindError(NoMinitel,true) then EndSoft;
end;

(********************************************)
(*                                          *)
(*                  DISK                    *)
(*                                          *)
(********************************************)

procedure AffInChamps(texte : string; max,champs,colonne,ligne : byte);
var buf   : string;
    tempo : integer;
begin
  buf := FillString(champs,32);
  tempo := length(texte)-(champs-1);
  if tempo<0 then tempo := 0;
  move(texte[tempo+1],buf[1],length(texte)-tempo);
  WriteScr(buf,CNorm,colonne,ligne);
end;

function InputString(var source : string; max,champs,colonne,ligne : byte) : boolean;
  procedure SetCurXY(x,y : byte);
  begin
    WrtByte(219,CNorm+128,x-1,y-1);
  end;
var texte : string;
    tempo,OfsX : integer;
    EndBoucle,GoodKey : boolean;
    index : byte;
    Good : boolean;
begin
  texte := source;
  EndBoucle := false;
  repeat
    AffInChamps(texte,max,champs,colonne,ligne);
    if length(texte)>=champs then OfsX := champs
    else OfsX := length(texte)+1;
    SetCurXY(colonne+OfsX,ligne+1);
    GoodKey := false;
    repeat
      ViewKey;
      if Not(FUNCT) then
        case key of
          #8 : begin (* del *)
                 GoodKey := true;
                 if length(texte)>0 then delete(texte,length(texte),1);
               end;
          #13 : begin (* return *)
                  Good := true;
                  EndBoucle := true;
                end;
          #27 : begin (* ESC *)
                  Good := false;
                  EndBoucle := true;
                  texte := source;
                end;
          #33..#127 : begin
                        GoodKey := true;
                        if length(texte)<max then
                          texte := texte+key;
                      end;
        end; (* case of *)
    until EndBoucle or GoodKey;
  until EndBoucle;
  UpCaseStr(texte);
  AffInChamps(texte,max,champs,colonne,ligne);
  source := texte;
  InputString := Good;
end;

function WindInputString(PreTexte : string; var texte : string;
                         Size : byte; x,y,Lg : byte) : boolean;
begin
  CreateWind(x,y,Lg,3);
  WriteScr(PreTexte,CInv,x+1,y+1);
  WindInputString := InputString(texte,Size,Lg-(length(PreTexte)+3),
                       x+length(PreTexte)+2,y+1);
  DepileWind;
end;

function LecteurExist(NumDisk : byte) : boolean;
(* ATTENTION : ne reconnait que A,B et C ou: *)
(* A(0) et B(1) disk souple, C(128) disk dur *)
const A = 0;
      B = 1;
      C = 128;
var rg : registers;
    SoapDisk : byte; (* nbre de lecteur disk souple *)
    HardDisk : byte; (* nbre de disk dur *)
begin
  rg.AX := $0800;
  if NumDisk >= 128 then
    begin
      rg.dl := NumDisk;
      intr($13,rg);
      if (rg.Flags and 1)<>0 then HardDisk := 0
      else HardDisk := rg.DL;
    end
  else HardDisk := 0;
  intr($11,rg);
  SoapDisk := (rg.AX and 1)*(((rg.AX shr 6) and 3)+1);
  case NumDisk of
    A,B : LecteurExist :=(SoapDisk>NumDisk);
    C : LecteurExist :=(HardDisk>0);
  else
    LecteurExist := false;
  end;
end;

function GoodSpecif(rep : string) : boolean;
var num : byte;
begin
  if (length(rep)>=2) and (rep[1] in ['A'..'E','a'..'e']) and (rep[2] = ':') then
    begin
      num := byte(rep[1])-65;
      if num>4 then num := num-32; (* pour les minuscules *)
      if num = 2 then num := 128;
      GoodSpecif := LecteurExist(num);
    end
  else
    GoodSpecif := true;
end;

procedure To6Bits(var Source,Destination);
var Tab8Bits  : array[1..3] of byte absolute Source;
    Tab6Bits  : array[1..4] of byte absolute Destination;
begin
  Tab6Bits[1] := (Tab8Bits[1] and 63);
  Tab6Bits[2] := ((Tab8Bits[1] shr 6) or
                  (Tab8Bits[2] shl 2)) and 63;
  Tab6Bits[3] := ((Tab8Bits[2] shr 4) or
                  (Tab8Bits[3] shl 4)) and 63;
  Tab6Bits[4] := ((Tab8Bits[3] shr 2) and 63);
end;

procedure To8Bits(var Source,Destination);
var Tab6Bits  : array[1..4] of byte absolute Source;
    Tab8Bits  : array[1..3] of byte absolute Destination;
begin
  Tab8Bits[1] := (Tab6Bits[1] and 63) or (Tab6Bits[2] shl 6);
  Tab8Bits[2] := ((Tab6Bits[2] and 63) shr 2) or
                 (Tab6Bits[3] shl 4);
  Tab8Bits[3] := ((Tab6Bits[3] and 63) shr 4) or
                 (Tab6Bits[4] shl 2);
end;

type MemBlk_map = record
                    point : pointer;
                    Lg    : word;
                  end;
const MxNbPaquet = 128; (* 128 paquets de 2700 octets -> 345 600 octets *)
      MxLgPaquet = 2700;
      MxLgSixtet = 3600;
type  Paquet_map = array[1..MxLgPaquet] of byte;
      Sixtet_map = array[1..MxLgSixtet] of byte;

var LgFichier    : LongInt; (* taille reelle du fichier *)
    LgMemFichier : LongInt; (* taille oqp en memoire (dans l'absolue) *)
    Paquet       : array[1..MxNbPaquet] of ^Paquet_map;
    SixtetIn     : Sixtet_map; (* standard *)
    NbPaquet     : byte; (* 0..MxNbPaquet *)

procedure OpenMemPaquet(LgFichier : LongInt);
var index : byte;
begin
  if (LgFichier mod 3)=0 then LgMemFichier := LgFichier
  else LgMemFichier := LgFichier+(3-(LgFichier mod 3));
  NbPaquet := (LgMemFichier div MxLgPaquet);
  for index := 1 to NbPaquet do New(Paquet[index]);
  if (LgMemFichier mod MxLgPaquet)<>0 then
    begin (* y'a des restes *)
      Inc(NbPaquet);
      New(Paquet[NbPaquet]);
    end;
  (* ATTENTION: meme si c'est impossible, prevoir NbMemBlk := 0! *)
end;

procedure CloseMemPaquet;
var index : byte;
begin
  for index := 1 to NbPaquet do Dispose(paquet[index]);
end;

function AbregeRep(Rep : string) : string;
var texte : string;
    index : byte;
begin
  if length(Rep)>32 then
    begin
      index := 4;
      while (Rep[index]<>'\') and (index<15) do Inc(index);
      texte := copy(rep,1,index)+'...';
      index := length(Rep);
      while (Rep[index]<>'\') and (index>(length(Rep)-12)) do Dec(index);
      texte := texte+copy(Rep,index,length(Rep)+1-index);
    end
  else texte := Rep;
  AbregeRep := CentreString(texte,32,32);
end;

const
      Xo = 1; Yo = 7; Lgo = 34;
procedure AffOctets(transmis,base : LongInt);
var buf : string;
    texte : string;
begin
  Str(transmis,texte);
  Str(base,buf);
  texte := texte+'/'+buf+' octet';
  if transmis>1 then texte := texte+'s';
  WriteScr(CentreString(texte+' transmis',Lgo-2,32),CNorm,Xo+1,Yo+1);
end;

const
      Xb = 1; Yb = 10; Lgb = 34;
procedure AffPaquets(transmis,base : LongInt);
var buf : string;
    texte : string;
begin
  Str(transmis,texte);
  Str(base,buf);
  texte := texte+'/'+buf+' paquet';
  if transmis>1 then texte := texte+'s';
  WriteScr(CentreString(texte+' transmis',Lgb-2,32),CNorm,Xb+1,Yb+1);
end;

procedure AffEscHelp;
begin
  WriteScr('Appuyer [Esc] pour sortir',CNorm,2,13);
end;

const Xmon = 45; Ymon = 4; Lgmon = 34; Htmon = 10;
var LineMon : byte;
procedure InitMonitor;
begin
  DessWind(Xmon,Ymon,Lgmon,Htmon);
  WriteScr(CentreString('Tracedesoprations',Lgmon-2,196),CNorm,Xmon+1,Ymon);
  LineMon := 0;
end;

procedure WriteMon(texte : string);
begin
  Inc(LineMon);
  if LineMon>HtMon-2 then
    begin
      LineMon := HtMon-2;
      EmpileWind(Xmon+1,Ymon+2,Xmon+LgMon-2,Ymon+Htmon-2);
      DepileWindTo(Xmon+1,Ymon+1);
    end;
  WriteScr(CentreString(texte,Lgmon-2,32),CInv,Xmon+1,Ymon+LineMon);
  if LineMon>1 then
    WindAspect(Xmon+1,Ymon+LineMon-1,Xmon+LgMon-2,Ymon+LineMon-1,CNorm);
end;

procedure DecoMinitel;
begin
  WriteCom(#0#0+             { prepare le terrain }
           #$1B#$5B#$3F#$7B+ { retour en mode videotex }
           #27#58#$32#$7E+   { fin du mode mixte }
           MPRO1+char($7F)+  (* reset *)
           MPRO1+char($67)+  (* deconnexion *)
           MPRO1+#$57+       { libration de la ligne }
           MPRO1+char($7F)); (* rereset *)

end;

procedure ResetMinitel;
begin
  WriteCom(MPRO3+MON+MRModem+MEPrise+     (* Prise   -> Modem *)
           MPRO3+MOFF+MREcran+MEPrise+    (* Prise   <> Ecran *)
           MPRO3+MOFF+MREcran+MEModem+    (* Modem   <> Ecran *)
           MPRO3+MOFF+MREcran+MEClavier+  (* Clavier <> Ecran *)
           MPRO3+MOFF+MRPrise+MEClavier+  (* Clavier <> Prise *)
           MPRO3+MOFF+MRModem+MEClavier); (* Clavier <> Modem *)
end;

procedure VideRS(HowManySec : LongInt);
begin
  SleepTime  := OneSec;
  GlobalTime := HowManySec;
  UserKey := #0;
  DualActivity := false;
  SetFilter(SleepTime,0,SleepTime,0,SleepTime,0);
  OrgGlobalTime := NbPulse;
  while not(NoMoreTime=GetData) do ;
end;

function GetThisPath(texte : string; HowManySec : LongInt) : shortInt;
var Info : SHortInt;
begin
  SleepTime  := HowManySec;
  GlobalTime := HowManySec;
  UserKey := #27;
  UserFunct := False;
  DualActivity := false;
  SetFilter(SleepTime,0,SleepTime,0,SleepTime,0);
  Info := GetPath(texte);
  if Info=1 then Info := 0;
  GetThisPath := Info;
end;

var LastOrder : string;
procedure SendOrder(texte : string);
begin
  WriteCom(texte);
  LastOrder := texte;
end;

procedure PutLongInt(x : LongInt; y : word);
var Mixo : record
             case byte of
               FALSE: (Lval  : LongInt; Wval  : word); (* LongInt apres SNL *)
               TRUE : (octet : array[1..6] of byte);
           end;
var sixtet : array[1..8] of byte;
    index  : byte;
    texte  : string[8];
begin
  Mixo.LVal := x;
  Mixo.WVal := y;
  To6Bits(Mixo.octet[1],sixtet[1]);
  To6Bits(Mixo.octet[4],sixtet[5]);
  Texte[0] := char(SizeOf(texte)-1);
  for index := 1 to 8 do texte[index] := char(sixtet[index] or 64);
  SendOrder(texte+NEWLINE);
end;

var GTIVal : record
               Exist : boolean; (* en cas de retour a SNL, indique si *)
                                (* un LongInt+Word peut etre valide   *)
               case byte of
                 FALSE: (Lval  : LongInt; Wval  : word); (* LongInt apres SNL *)
                 TRUE : (octet : array[1..6] of byte);
             end;
    LgGTI    : word;    (* longueur de sixtet accumule dans sixtet^[...] *)
                        (* note: la limite est MxLgSixtet et les donnes *)
                        (*       en trop sont perdu.                    *)
                        (* mettre LgGTI a zero afin d'initialiser       *)
    LgGTIdeb : boolean; (* indique si un debordement du buffer sixtet   *)
                        (* c'est produit. AutoInitialise dans Geting    *)
    GTICode  : ShortInt; (* dernier code retourne par GetIng *)

function GetIng : ShortInt;
(* il s'agit de la function principale d'echange d'information *)
(* retourne les erreurs produites (depassement de temps)       *)
(* Gere l'action sur Esc (->Fin)                               *)
(* accumule les Sixtets dans le buffer standard                *)
(* conserve le dernier LongInt+Word envoye                     *)
(* retourne FOk,FNo,FFin,FNL                                   *)
(* FRep est autogere et ne peut etre une cause de retour       *)
(* DualActivity,Multitache et InitSleepTime non initialise!!   *)
(* Idem pour SleepTime et GlobalTime                           *)
var EndBoucle : boolean;
    Info : ShortInt;
begin
  UserKey := #27;
  UserFunct := False;
  SetFilter(SleepTime,0,SleepTime,0,TrieFilt,LgTrieFilt);
  GTIVal.Exist := false;
  EndBoucle := false;
  if LgGTI>MxLgSixtet then
    begin
      LgGTI := MxLgSixtet;
      LgGTIdeb := true; (* debordement *)
    end
  else LgGTIdeb := false; (* pas de debordement *)
  repeat
    Info := FindPath(Pathos,LgPathos);
    if Info>0 then
      if Info=FRep then SendOrder(LastOrder) (* seul cas autogere *)
      else
        begin (* final *)
          if Info=FNL then
            if LgGTI>=8 then
              begin (* information a prendre *)
                GTIVal.Exist := TRUE;
                To8Bits(SixtetIn[LgGTI-7],GTIVal.octet[1]);
                To8Bits(SixtetIn[LgGTI-3],GTIVal.octet[4]);
              end
            else GTIVal.Exist := FALSE
          else
            GTIVal.Exist := FALSE;
          EndBoucle := True;
        end
    else (* info<=0 *)
      case Info of
        TrieCode : begin
                     Inc(LgGTI);
                     if LgGTI>MxLgSixtet then
                       begin
                         LgGTI := MxLgSixtet;
                         LgGTIdeb := true;
                       end
                     else
                       begin
                         SixtetIn[LgGTI] := CurrentData and 63;
                         LgGTIdeb := false;
                       end;
                       (* on accumule *)
                     Multitache := true; (* n'initialise pas FindPath *)
                   end;
        TooLate  : begin (* sleepTime *)
                     WriteCom(SRep); (* demande de repete le dernier ordre *)
                     (* Note: SRep n'est pas un ordre, ainsi, si le recept *)
                     (* demande a repete, il n'aura pas SRep comme reponse! *)
                     Multitache := true; (* on n'affecte pas GlobalTime *)
                     InitSleepTime := true; (* on initialise sleep *)
                     (* reprise jusqu'a une bonne reponse ou autres info *)
                   end;
        NoMoreTime : EndBoucle := true; (* GlobalTime *)
        UserAction : EndBoucle := true; (* Esc *)
        PassRelay  : EndBoucle := true; (* Multitache reel en cours *)
      end;
  until EndBoucle;
  GTICode := Info;
  GetIng  := Info;
end;

function PutGetLongInt(x : LongInt; y : word) : ShortInt;
(* envoi un entier long+word et attend son renvoi          *)
(* si l'operation se passe bien on envoi SOk sinon abandon *)
(* en retour, si <>0 alors erreur, si =0 alors ok *)
var Essai : byte;
    EndBoucle : boolean;
    info : ShortInt;
begin
  LgGTI := 0; (* sixtetIn *)
  SleepTime := OneSec*3;
  GlobalTime := TenSec;
  DualActivity := False;
  Multitache := False;
  InitSleepTime := true;
  Essai := 0;
  repeat
    PutLongInt(x,y); (* envoi de LongInt+word *)
    repeat
      EndBoucle := true;
      Info:=GetIng;
      if (Info=FOk) or (Info=FNon) then
        begin (* on ignore sans initialisation *)
          Multitache := true;
          EndBoucle  := False;
        end;
    until EndBoucle;
    if Info>0 then (* Path trouve *)
      begin
        if Info=FNL then
          if (GTIVal.Exist) and (GTIVal.LVal=x) and (GTIVal.WVal=y) then
            begin
              SendOrder(SOk);
              Info := 0;
            end
          else
            begin
              Inc(Essai);
              if Essai<3 then
                begin
                  EndBoucle := False;
                  Multitache := true; (* afin de ne pas initialiser FindPath *)
                end
              else Info := FNon;
            end;
      end;
  until EndBoucle;
  PutGetLongInt := Info;
end;

function PutGetString(texte : string) : ShortInt;
(* ne pas rajouter de NewLine!                             *)
(* envoi une chaine et attend son renvoi                   *)
(* il s'agit d'une obligatoirement differente des ordres!  *)
(* avec des codes valide (pas sixtet)                      *)
(* si l'operation se passe bien on envoi SOk sinon abandon  *)
(* en retour, si <>0 alors erreur, si =0 alors ok           *)
(* ATTENTION: Pathos est temporairement detourne!!!         *)
(*           Pathos[FNL] := #255#255...#255#10#13           *)
(* ainsi, on peut recupere la chaine envoye dans PathResult *)
var Essai : byte;
    EndBoucle : boolean;
    info : ShortInt;
begin
  LgGTI := 0; (* sixtetIn *)
  SleepTime := OneSec*3;
  GlobalTime := TenSec;
  DualActivity := False;
  Multitache := False;
  InitSleepTime := true;
  Essai := 0;
  Tronque(texte,SizeOf(PathResult)-3);
  FillChar(Pathos[FNL][1],length(texte),255);
  Pathos[FNL][0] := texte[0];
  Pathos[FNL] := Pathos[FNL]+NewLine;
  repeat
    SendOrder(texte+NEWLINE);
    repeat
      EndBoucle := true;
      Info:=GetIng;
      if (Info=FOk) or (Info=FNon) then
        begin (* on ignore sans initialisation *)
          Multitache := true;
          EndBoucle  := False;
        end;
    until EndBoucle;
    if Info>0 then (* Path trouve *)
      begin
        if Info=FNL then
          if PathResult=texte+NewLine then
            begin
              SendOrder(SOk);
              Info := 0;
            end
          else
            begin
              Inc(Essai);
              if Essai<3 then
                begin
                  EndBoucle := False;
                  Multitache := true; (* afin de ne pas initialiser FindPath *)
                end
              else Info := FNon;
            end;
      end;
  until EndBoucle;
  Pathos[FNL] := NewLine; (* restitue le Pathos standard *)
  PutGetString := Info;
end;

function GetPutString(Lg : byte) : ShortInt;
(* attend une chaine quelconque suivit de NewLine      *)
(* il faut cependant indiquer la longueur de la chaine *)
(* la renvoi et attend SOk                             *)
var Essai : byte;
    EndBoucle : boolean;
    Info : ShortInt;
begin
  LgGTI := 0; (* sixtetIn *)
  SleepTime := OneSec*3;
  GlobalTime := TenSec;
  DualActivity := False;
  Multitache := False;
  InitSleepTime := true;
  Essai := 0;
  if Lg>(SizeOf(StringPath)-3) then Lg := (SizeOf(StringPath)-3);
  FillChar(Pathos[FNL][1],Lg,255);
  Pathos[FNL][0] := char(Lg);
  Pathos[FNL] := Pathos[FNL]+NEWLINE; (* Lg codes quelconque + NewLine *)
  repeat
    repeat
      EndBoucle := true;
      Info := GetIng;
      if (Info=FOk) or (Info=FNon) then
        begin (* ignore sans init *)
          Multitache := true;
          EndBoucle  := False;
        end;
    until EndBoucle;
    repeat
      if Info=FNL then
        begin (* on renvoi ce qu'on a recu *)
          SendOrder(PathResult);
          Multitache := true;
          repeat
            EndBoucle := true;
            Info := GetIng;
            if (Info=FNon) then
              begin (* on ignore *)
                Multitache := true;
                EndBoucle  := false;
              end;
          until EndBoucle;
          if Info=FOk then
            begin
              EndBoucle := true;
              Info := 0; (* ca roule! *)
            end
          else EndBoucle := false;
        end
      else EndBoucle := true;
    until EndBoucle;
  until EndBoucle;
  Pathos[FNL] := NewLine; (* restitue le Pathos standard *)
  GetPutString := Info;
end;

function GetPutLongInt(var x : LongInt; var y : word) : ShortInt;
(* attend un Entier Lond+Word quelconque               *)
(* le renvoi et attend SOk                             *)
var Essai : byte;
    EndBoucle : boolean;
    Info : ShortInt;
begin
  LgGTI := 0; (* sixtetIn *)
  SleepTime := OneSec*3;
  GlobalTime := TenSec;
  DualActivity := False;
  Multitache := False;
  InitSleepTime := true;
  Essai := 0;
  repeat
    repeat
      EndBoucle := true;
      Info := GetIng;
      if (Info=FOk) or (Info=FNon) or ((Info=FNL) and not(GTIVal.Exist)) then
        begin (* ignore sans init *)
          Multitache := true;
          EndBoucle  := False;
        end;
    until EndBoucle;
    repeat
      if (Info=FNL) and (GTIVal.Exist) then
        begin (* on renvoi ce qu'on a recu *)
          x := GTIVal.LVal;
          y := GTIVal.WVal;
          PutLongInt(x,y);
          Multitache := true;
          repeat
            EndBoucle := true;
            Info := GetIng;
            if (Info=FNon) or ((Info=FNL) and not(GTIVal.Exist)) then
              begin (* on ignore *)
                Multitache := true;
                EndBoucle  := false;
              end;
          until EndBoucle;
          if Info=FOk then
            begin
              EndBoucle := true;
              Info := 0; (* ca roule! *)
            end
          else EndBoucle := false;
        end
      else EndBoucle := true;
    until EndBoucle;
  until EndBoucle;
  GetPutLongInt := Info;
end;

function GetOk : ShortInt;
var EndBoucle : boolean;
    Info : ShortInt;
begin
  LgGTI := 0; (* sixtetIn *)
  SleepTime := OneSec*3;
  GlobalTime := TenSec;
  DualActivity := False;
  Multitache := False;
  InitSleepTime := true;
  repeat
    Info := GetIng;
    EndBoucle := not((Info=FNon) and (Info=FNL));
  until EndBoucle;
  if Info=FOk then Info := 0;
  GetOk := Info;
end;

function LongPaquet(NumPaquet : byte) : word;
(* retourne la longueur du paquet courant *)
(* definie en fonction de la taille oqp en memoire *)
begin
  if NumPaquet>=NbPaquet then (* dernier paquet *)
    LongPaquet := (LgMemFichier-((NumPaquet-1)*MxLgPaquet))
  else LongPaquet := MxLgPaquet;
end;

procedure Jauge(Pos : word; octet : byte;
                var LIctrl : LongInt; var Wctrl : word);
begin
(*
  Inc(LIctrl,octet);
  if (octet and 1)=0 then
    Inc(Wctrl,(Pos and 15));
*)
  Inc(LIctrl,LongInt(Pos)*(octet+1));
  if (octet and 1)=0 then Inc(Wctrl,Pos) else Dec(Wctrl,Pos);
end;

function EnvoiPaquet(NumPaquet : byte) : ShortInt;
var Essai : byte;
    SixtetOut : ^Sixtet_map;
    NbSixtetSend : word; (* nombre de Sixtet envoye *)
    LIctrl : LongInt; (* entier long de controle *)
    Wctrl  : word   ; (* le mot de controle *)
    EndBoucle : boolean;
    Index,J : word;
    LgOctet : word; (* contient la vrai longueur du paquet *)
    LgSixtet : word;
    x : LongInt;
    y : word;
    Info : ShortInt;
begin
  New(SixtetOut);
  LgOctet := LongPaquet(NumPaquet); (* definition de la vrai longueur du paquet *)
  LgSixtet := ((4*LgOctet) div 3);
  (* Lg doit etre divisible par 3!! (Lg Mod 3=0) *)
  (* on transforme le paquet d'octet en sixtet dans SixtetOut *)
  (* et on etablie LIctrl et Wctrl *)
  Index := 1;
  J := 1;
  LIctrl := 0;
  Wctrl  := 0;
  while (Index<=LgOctet) do
    begin
      To6Bits(Paquet[NumPaquet]^[Index],SixtetOut^[J]);
      for Index := Index to Index+2 do
        Jauge(Index,Paquet[NumPaquet]^[Index],LIctrl,Wctrl);
      Inc(Index);
      Inc(J,4);
    end;

  Essai := 0; (* nombre d'essai *)
  repeat
    NbSixtetSend := 0; (* aucun sixtet envoye *)

    LgGTI := 0; (* sixtetIn *)
    SleepTime := FiveSec+((LongInt(LgSixtet)*(OneSec+1)) div 120);
    GlobalTime := SleepTime;
    DualActivity := TRUE; (* on autorise le MultiTache *)
    Multitache := False;
    InitSleepTime := true;

    repeat
      repeat
        EndBoucle := true;
        Info := Geting;
        if (Info=FOk) or (Info=FNon) or (Info=FNL) then
          begin (* on ignore ces flags *)
            Multitache := true;
            EndBoucle  := false;
          end;
      until EndBoucle;
      EndBoucle := true;
      if Info=PassRelay then
        begin (* on envoi 1 sixtet *)
          PutData(SixtetOut^[NbSixtetSend+1] or 64);
          Inc(NbSixtetSend);
          EndBoucle := (NbSixtetSend>=LgSixtet);
        end;
    until EndBoucle;
    SendOrder(NewLine); (* clos l'envoi du paquet *)
     (* dans tout les cas *)
    if Info=PassRelay then
      begin (* tout se passe bien *)
        Info := GetPutLongInt(x,y);
        if Info=0 then
          (* le recepteur a renvoye les valeurs de controle *)
          begin
            if (x=LIctrl) and (y=Wctrl) then
              begin
                SendOrder(SOk);
                Info := GetOk;
                EndBoucle := true;
              end
            else
              begin
                Inc(Essai);
                if Essai<=MxEssaiPaquet then
                  begin
                    SendOrder(SNon);
                    Info := GetOk;
                    EndBoucle := (Info<>0);
                  end
                else
                  begin
                    Info := NoMoreTime;
                    EndBoucle := true; (* plus d'essai *)
                  end;
              end;
          end
        else EndBoucle := true;
      end;
  until EndBoucle;
  EnvoiPaquet := Info;
  Dispose(SixtetOut);
end;

function DiffPaquets : ShortInt;
var Index : byte;
    Info  : ShortInt;
    buf   : string;
    NbOctetSend : LongInt;
begin
  NbOctetSend := 0;
  Index := 1;
  Info := 0;
  while (Index<=NbPaquet) and (Info=0) do
    begin
      Str(Index,buf);
      WriteMon('Envoi du paquet n '+buf);
      Info := (EnvoiPaquet(index));
      if Info=0 then
        begin
          WriteMon('Ok.');
          AffPaquets(Index,NbPaquet);
          Inc(NbOctetSend,LongPaquet(Index));
          AffOctets(NbOctetSend,LgFichier);
        end
      else WriteMon('Mauvais envoi.');
      Inc(Index);
    end;
  DiffPaquets := Info;
end;

function YesOrNo(texte : string; EscActif : boolean) : boolean;
const X = 18; Y = 7; Lg = 44; Ht = 8;
var EndBoucle,Good : boolean;
    index : byte;
begin
  CreateWind(X,Y,Lg,Ht);
  EmpileBlk;
  WriteScr(CentreString(texte,Lg-2,32),CSurI,X+1,Y+2);
  WriteChoix('  NON  ',Field[13].X,Field[13].Y);
  WriteChoix('  OUI  ',Field[14].X,Field[14].Y);
  OneBlock(2,2,false,false);
  for index := 13 to 14 do ChsSpc(NbBlk,index);
  SelectSpc := 1; SelectBlk := NbBlk;
  EndBoucle := false;
  repeat
    if Interaction then
      begin
        EndBoucle := true;
        Good := (SelectSpc=2);
      end
    else
      if EscKey and EscActif then
        begin
          EndBoucle := true;
          Good := false;
        end;
  until EndBoucle;
  DepileBlk;
  DepileWind;
  YesOrNo := Good;
end;

procedure ItsAllRight;
const X = 18; Y = 12; Lg = 44; Ht = 5;
begin
  EmpileWind(X,Y,X+Lg-1,Y+Ht-1);
  ClrZone(X,Y,X+Lg-1,Y+Ht-1,CNorm);
  MakeCadre(X,Y,X+Lg-1,Y+Ht-1,CNorm+128);
  WriteScr(CentreString('Fichier totalement transmis',Lg-2,32),CSurI,X+1,Y+1);
  InviteKey(X+1,Y+Ht-2,Lg-2);
  DepileWind;
end;

function EmissionFichier(Rep : string) : boolean;
  function GetReady : boolean;
  const X = 18; Y = 12; Lg = 44; Ht = 5;
  begin
    EmpileWind(X,Y,X+Lg-1,Y+Ht-1);
    ClrZone(X,Y,X+Lg-1,Y+Ht-1,CNorm);
    MakeCadre(X,Y,X+Lg-1,Y+Ht-1,CNorm+128);
    WriteScr(CentreString('ATTENTION: La transmission va commencer.',Lg-2,32),CSurI,X+1,Y+1);
    InviteKey(X+1,Y+Ht-2,Lg-2);
    DepileWind;
    GetReady := not(EscKey);
  end;
const X = 0; Y = 3; Lg = 80; Ht = 12;
      Xn = 1; Yn = 4; Lgn = 34;
var EndBoucle : boolean;
    Good : boolean;
    Info : ShortInt;
    bidon : word;
begin
 repeat
  LastOrder := ''; (* il n'y a pas de dernier ordre *)
  CreateWind(X,Y,Lg,Ht);
  DessWind(Xn,Yn,Lgn,3);
  WriteScr(AbregeRep(Rep),CNorm,Xn+1,Yn+1);
  DessWind(Xo,Yo,Lgo,3);
  AffOctets(0,LgFichier);
  DessWind(Xb,Yb,Lgb,3);
  AffPaquets(0,NbPaquet);
  AffEscHelp;
  InitMonitor;
  WriteMon('OK.');
  Good := false;
  repeat
    EndBoucle := true; (* a priori *)
    if GetReady then
      begin
        WriteMon('Initialisation du minitel');
        DecoMinitel;
        VideRS(OneSec);
        WriteMon('Emission de la porteuse');
        WriteCom(MPRO1+#$53); { prise de ligne }
        WriteCom(MPRO1+#$6F); (* opposition minitel *)
        WriteCom(MPRO1+#$68); (* connexion *)
        Info := GetThisPath(#19#83,TenSec+FiveSec);
        if Info=0 then
          begin
            WriteMon('Communication tablie');
            WriteCom(Bourratif);
            ResetMinitel;
            VideRS(OneSec);
            WriteCom(Bourratif);
            WriteMon('Synchronisation');
            Info := PutGetString(Porteuse);
            if Info=0 then
              begin
                WriteMon('Envoi de longueur');
                Info := PutGetLongInt(LgFichier,TypeTransfert);
                if Info=0 then
                  begin
                    WriteMon('Recepteur prt?');
                    Info := GetPutString(length(ImReady));
                      (* on get et renvoi jusqu'a sok *)
                    if Info=0 then
                      begin
                        WriteMon('debut de diffusion');
                        Info := DiffPaquets;
                        if Info=0 then WriteMon('Fichier totalement transmis')
                        else WriteMon('Fin anormale');
                      end;
                  end;
                EndBoucle := true;
              end;
          end;
        SendOrder(SFin);
        SendOrder(SFin);
        WriteCom(Bourratif+Bourratif);
        WriteMon('Dconnexion');
        VideRS(OneSec);
        DecoMinitel;
        WriteCom(Bourratif+Bourratif);
        Sound(1130);
        VideRS(OneSec div 2);
        NoSound;
        if Info<>0 then
          begin
            case Info of
              NoMoreTime : bidon := E_NoMoreTime;
              TooLate    : bidon := E_TooLate;
              UserAction : bidon := E_UserAction;
              FFin       : bidon := E_FFin;
              FNon       : bidon := E_FNon;
            else bidon := 255;
            end;
            bidon := WindError(bidon,false);
            Good := false;
          end
        else Good := true;
        EndBoucle := true;
      end;
  until EndBoucle;
  if Good then ItsAllRight
  else EndBoucle := not(YesOrNo('Souhaitez-vous recommencer?',false));
  DepileWind;
 until Good or EndBoucle;
  EmissionFichier := Good;
end;

function Chargement(rep : string) : boolean;
const X = 10; Y = 3; Lg = 60; Ht = 3;
var bidon : byte;
    fichier : File;
    io : word;
    Good : boolean;
    NbPaquetIn : byte;
    NbByteIn   : word;
    buf : string;
begin
  CreateWind(X,Y,Lg,Ht);
  buf := AbregeRep(Rep);
  KillData(buf,32);
  WriteScr(CentreString('En chargement : '+buf+' ...',Lg-2,32),
           CNorm,X+1,Y+1);
  Good := false;
  if GoodSpecif(rep) then
    begin
      (*$I-*)
      assign(fichier,Rep);
      reset(fichier,1);
      io := ioresult;
      if io=0 then
        begin
          LgFichier := FileSize(fichier);
          io := ioresult;
          if LgFichier=0 then io := EmptyFile; (* c'est une erreur *)
          if io=0 then
            begin
              OpenMemPaquet(LgFichier);
              NbByteIn := 0;
              NbPaquetIn := 0;
              repeat
                Inc(NbPaquetIn);
                BlockRead(fichier,Paquet[NbPaquetIn]^,MxLgPaquet,NbByteIn);
                io := ioresult;
              until (io<>0) or (NbPaquetIn>=NbPaquet);
              if io=0 then
                begin
                  close(fichier);
                  io := ioresult;
                  if io=0 then Good := EmissionFichier(Rep);
                end;
              CloseMemPaquet;
            end;
        end;
      bidon := WindError(io,false);
      (*$IFDEF DEBUG *) (*$I+*) (*$ENDIF *)
    end
  else bidon := WindError(15,false);
  DepileWind;
  Chargement := Good;
end;

function Emission : boolean;
  function GetReady(Rep : string) : boolean;
  const X = 20; Y = 2; Lg = 40; Ht = 7;
  begin
    CreateWind(X,Y,Lg,Ht);
    WriteScr(CentreString('Le chemin d''accs est:',Lg-2,32),CNorm,X+1,Y+1);
    WriteScr(CentreString(AbregeRep(Rep),Lg-2,32),CNorm,X+1,Y+2);
    WriteScr(CentreString('Appuyer une touche afin',Lg-2,32),CInv,x+1,y+4);
    WriteScr(CentreString('de charger le fichier',Lg-2,32),CInv,x+1,y+5);
    GetKey;
    DepileWind;
    GetReady := not(EscKey);
  end;
const X = 7; Y = 2; Lg = 66;
var Rep : string;
    EndBoucle : boolean;
    Good : boolean;
begin
  Rep := '';
  repeat
    Good := false;
    EndBoucle := true;
    if WindInputString('Chemin d''accs au fichier:',
                     Rep,SizeOf(Rep)-1,X,Y,Lg) then
      if (Rep<>'') then
        begin
          if GetReady(Rep) then
            begin
              Good := Chargement(Rep);
              EndBoucle := true;
            end
          else EndBoucle := false;
        end;
  until EndBoucle;
  Emission := Good;
end;

function Sauvegarde(rep : string) : boolean;
  function LongPaquet(NumPaquet : byte) : word;
  (* retourne la longueur du paquet courant *)
  (* definie en fonction de la taille reelle du fichier *)
  begin
    if NumPaquet>=NbPaquet then (* dernier paquet *)
      LongPaquet := (LgFichier-((NumPaquet-1)*MxLgPaquet))
    else LongPaquet := MxLgPaquet;
  end;
const X = 10; Y = 12; Lg = 60; Ht = 3;
var bidon : byte;
    fichier : File;
    Good : boolean;
    buf : string;
    index : byte;
    NbByteOut : word;
    io : word;
begin
  CreateWind(X,Y,Lg,Ht);
  buf := AbregeRep(Rep);
  KillData(buf,32);
  WriteScr(CentreString('En sauvegarde : '+buf+' ...',Lg-2,32),
           CNorm,X+1,Y+1);
  Good := false;
  if GoodSpecif(rep) then
    begin
      (*$I-*)
      assign(fichier,Rep);
      rewrite(fichier,1);
      io := ioresult;
      if io=0 then
        begin
          index := 1;
          while (index<=NbPaquet) and (io=0) do
            begin
              BlockWrite(fichier,Paquet[index]^,LongPaquet(index),NbByteOut);
              io := ioresult;
              Inc(index);
            end;
          if io=0 then
            begin
              close(fichier);
              io := ioresult;
              Good := (io=0);
            end;
        end;
      bidon := WindError(io,false);
      (*$IFDEF DEBUG *) (*$I+*) (*$ENDIF *)
    end
  else bidon := WindError(15,false);
  DepileWind;
  Sauvegarde := Good;
end;

procedure SauvegardeReception;
  function GetReady(Rep : string) : boolean;
  const X = 20; Y = 12; Lg = 40; Ht = 7;
  begin
    CreateWind(X,Y,Lg,Ht);
    WriteScr(CentreString('Le chemin de destination est:',Lg-2,32),CNorm,X+1,Y+1);
    WriteScr(CentreString(AbregeRep(Rep),Lg-2,32),CNorm,X+1,Y+2);
    WriteScr(CentreString('Appuyer une touche afin',Lg-2,32),CInv,x+1,y+4);
    WriteScr(CentreString('de sauvegarder le fichier',Lg-2,32),CInv,x+1,y+5);
    GetKey;
    DepileWind;
    GetReady := not(EscKey);
  end;
const X = 7; Y = 13; Lg = 66;
var Rep : string;
    EndBoucle : boolean;
    Good : boolean;
begin
  Rep := '';
  repeat
    repeat
      Good := false;
      EndBoucle := true;
      if WindInputString('Chemin de destination du fichier:',
                         Rep,SizeOf(Rep)-1,X,Y,Lg) then
        if (Rep<>'') then
          begin
            if GetReady(Rep) then
              begin
                Good := Sauvegarde(Rep);
                EndBoucle := true;
              end
            else EndBoucle := false;
          end;
    until EndBoucle;
    if not(Good) then
      EndBoucle := YesOrNo('Souhaitez-vous abandonner la sauvegarde ?',true);
  until EndBoucle;
  (* SauvegardeReception := Good; *)
end;

function GetOkouNon : ShortInt;
var EndBoucle : boolean;
    Info : ShortInt;
begin
  LgGTI := 0; (* sixtetIn *)
  SleepTime := OneSec*3;
  GlobalTime := TenSec;
  DualActivity := False;
  Multitache := False;
  InitSleepTime := true;
  repeat
    Info := GetIng;
    EndBoucle := Info<>FNL;
  until EndBoucle;
  GetOkouNon := Info;
end;

function ReceptPaquet(NumPaquet : byte) : ShortInt;
var SixtetOut  : sixtet_map;
    LIctrl     : LongInt;
    Wctrl      : word;
    EndBoucle  : boolean;
    LgOctet,LgSixtet : word;
    Info : ShortInt;
    Essai : byte;
    Index,J : word;
begin
  Essai := 0;
  LgOctet := LongPaquet(NumPaquet);
  LgSixtet := ((4*LgOctet) div 3);
  repeat
    LgGTI := 0; (* sixtetIn *)
    SleepTime := FiveSec+((LongInt(LgSixtet)*(OneSec+1)) div 120);
    GlobalTime := SleepTime;
    DualActivity := false;
    Multitache := False;
    InitSleepTime := true;
    repeat
      EndBoucle := true;
      Info := GetIng;
      if (Info=FOk) or (Info=FNon) then
        begin (* on ignore *)
          Multitache := true;
          EndBoucle := false;
        end;
    until EndBoucle;
    if Info=FNL then
      begin (* NewLine detecte, donc le buffer SixtetIn contient *)
            (* tout les sixtets entree, Lg=LgGTI *)
            (* on analyse tout ce qui a ete recu *)
        Index := 1;
        J := 1;
        LIctrl := 0;
        Wctrl  := 0;
        while (Index<=LgOctet) do
          begin
            To8Bits(SixtetIn[J],Paquet[NumPaquet]^[Index]);
            for Index := Index to Index+2 do
              Jauge(Index,Paquet[NumPaquet]^[Index],LIctrl,Wctrl);
            Inc(Index);
            Inc(J,4);
          end;
        if (LgGTI<>LgSixtet) or (LgGTIdeb) then
          begin
          (* la taille du paquet n'etant pas conforme     *)
          (* on introduit un resultat necessairement faux *)
            LIctrl := 0;
            Wctrl  := 0;
          end;
        Info := PutGetLongInt(LIctrl,Wctrl);
        if Info=0 then
          begin
            (* on attend la reponse SOk ou SNo *)
            Info := GetOkouNon;
            if (Info=FOk) or (Info=FNon) then
              begin
                SendOrder(SOk);
                if Info=FOk then Info := 0
                else (* FNon *)
                  begin
                    Inc(Essai);
                    if Essai<=MxEssaiPaquet then EndBoucle := False
                    else Info := NoMoreTime;
                  end;
              end;
          end;
      end
  until EndBoucle;
  ReceptPaquet := Info;
end;

function ReceptionPaquets : ShortInt;
var Index : byte;
    Info  : ShortInt;
    buf   : String;
    NbOctetRecu : LongInt;
begin
  NbOctetRecu := 0;
  Index := 1;
  Info := 0;
  while (Index<=NbPaquet) and (Info=0) do
    begin
      Str(Index,buf);
      WriteMon('Reception du paquet n '+buf+' ...');
      Info := ReceptPaquet(Index);
      if Info=0 then
        begin
          WriteMon('Ok.');
          AffPaquets(Index,NbPaquet);
          Inc(NbOctetRecu,LongPaquet(Index));
          AffOctets(NbOctetRecu,LgFichier);
        end
      else WriteMon('Mauvaise rception.');
      Inc(Index);
    end;
  ReceptionPaquets := Info;
end;

procedure ItsMarvelous;
const X = 18; Y = 13; Lg = 44; Ht = 5;
begin
  EmpileWind(X,Y,X+Lg-1,Y+Ht-1);
  ClrZone(X,Y,X+Lg-1,Y+Ht-1,CNorm);
  MakeCadre(X,Y,X+Lg-1,Y+Ht-1,CNorm+128);
  WriteScr(CentreString('Fichier totalement reu',Lg-2,32),CSurI,X+1,Y+1);
  InviteKey(X+1,Y+Ht-2,Lg-2);
  DepileWind;
end;

function ReceptionFichier : boolean;
const X = 0; Y = 3; Lg = 80; Ht = 12;
      Xn = 1; Yn = 4; Lgn = 34;
var EndBoucle,Good,MemPaquetActif : boolean;
    Info : ShortInt;
    bidon : word;
    TT    : word; (* type de transfert *)
begin
  LastOrder := ''; (* il n'y a pas de dernier ordre *)
  CreateWind(X,Y,Lg,Ht);
  DessWind(Xn,Yn,Lgn,3);
  WriteScr(CentreString('',Lgn-2,32),CNorm,Xn+1,Yn+1);
  DessWind(Xo,Yo,Lgo,3);
  DessWind(Xb,Yb,Lgb,3);
  AffEscHelp;
  InitMonitor;
  WriteMon('OK.');
  Good := false;
  MemPaquetActif := false;
  repeat
    EndBoucle := true;
    WriteMon('Initialisation du minitel');
    DecoMinitel;
    VideRS(OneSec);
    WriteMon('Connexion en cours ...');
    WriteCom(MPRO1+#$53); { prise de ligne }
    WriteCom(MPRO1+#$68);
    Info := GetThisPath(#19#83,TenSec+FiveSec);
    if Info=0 then
      begin
        WriteMon('Communication tablie');
        ResetMinitel;
        VideRS(OneSec);
        WriteMon('Synchronisation');
        WriteCom(Bourratif);
        Info := GetPutString(length(Porteuse));
        if Info=0 then
          begin
            WriteMon('Reception de longueur');
            Info:=GetPutLongInt(LgFichier,TT);
            if Info=0 then
              begin
                WriteMon('Ok');
                OpenMemPaquet(LgFichier); (* ouvre toute les memoires *)
                MemPaquetActif := true; (* et l'indique *)
                AffOctets(0,LgFichier);
                AffPaquets(0,NbPaquet);
                WriteMon('Prt.');
                Info := PutGetString(ImReady);
                if Info=0 then
                  begin
                    Info := ReceptionPaquets;
                  end;
              end;
          end;
      end;
    SendOrder(SFin);
    SendOrder(SFin);
    WriteCom(Bourratif);
    WriteMon('Dconnexion');
    VideRS(OneSec);
    DecoMinitel;
    WriteCom(Bourratif);
    Sound(1130);
    VideRS(OneSec div 2);
    NoSound;
    if Info=0 then
      begin (* il faut maintenant disposer du fichier *)
        WriteMon('Fichier totalement reu');
        ItsMarvelous;
        SauvegardeReception;
      end;
    if MemPaquetActif then CloseMemPaquet;
    if Info<>0 then
      begin
        case Info of
          NoMoreTime : bidon := E_NoMoreTime;
          TooLate    : bidon := E_TooLate;
          UserAction : bidon := E_UserAction;
          FFin       : bidon := E_FFin;
          FNon       : bidon := E_FNon;
        else bidon := 255;
        end;
        bidon := WindError(bidon,false);
       Good := false;
     end
    else Good := true;
  until EndBoucle;
  DepileWind;
  ReceptionFichier := Good;
end;

function Reception : boolean;
  function GetReady : boolean;
  const X = 18; Y = 8; Lg = 44; Ht = 6;
  begin
    EmpileWind(X,Y,X+Lg-1,Y+Ht-1);
    ClrZone(X,Y,X+Lg-1,Y+Ht-1,CNorm);
    MakeCadre(X,Y,X+Lg-1,Y+Ht-1,CNorm+128);
    WriteScr(CentreString('Votre correspondant a la main.',Lg-2,32),CSurI,X+1,Y+1);
    WriteScr(CentreString('Attendez le signal de la porteuse',Lg-2,32),CSurI,X+1,Y+2);
    InviteKey(X+1,Y+Ht-2,Lg-2);
    DepileWind;
    GetReady := not(EscKey);
  end;
var EndBoucle,Good : boolean;
begin
  repeat
    Good := false;
    EndBoucle := true;
    if GetReady then
      begin
        Good := ReceptionFichier;
      end;
  until EndBoucle;
  Reception := Good;
end;

procedure OnLine;
  procedure AffMenu;
  const X = 27;
        Y = 4;
        Lg = 26;
        Ht = 4;
  var index : byte;
  begin
    DessWind(X,Y,Lg,Ht);
    OneBlock(1,2,false,false);
    ChsStr('Emission d''un fichier',NbBlk,5);
    ChsStr('Rception d''un fichier',NbBlk,6);
  end;
var EndBoucle : boolean;
    bidon : byte;
begin
  AffMenu;
  repeat
    EndBoucle := false;
    repeat
      if interaction then
        case SelectSpc of
          1 : bidon := byte(Emission);
          2 : bidon := byte(Reception);
        end
      else EndBoucle := EscKey;
    until EndBoucle;
  until YesOrNo('QUITTER '+SOFTNAME+' ?',true);
end;

begin
  GestParam;
  InitSoft;
  OnLine;
  EndSoft;
end.
