{$IFDEF VER40 }

  {$R-,S-,I-,D-,T-,F-,V-,B-,N-,L- }
  {$M 16384,0,655360 }

{$ELSE }

  {$A-,B-,D+,E-,F-,I-,L+,N-,O-,R-,S-,V- }
  {$M 16384,0,655360 }

{$ENDIF }

(*********************************************************)
(*                                                       *)
(*                    INTER-SPC V1.0                     *)
(*                                                       *)
(*********************************************************)

Unit Interspc;
interface

uses dos,videosys,Crt;

type
      space_map     = record
                        X    : byte; (* coord champ *)
                        Y    : byte;
                        Lg   : byte; (* longueur *)
                        Ht   : byte; (* hauteur  *)
                      end;
     Spc_map        = record
                        Space  : byte; (* champs vrai origine *)
                        Chut   : boolean; (* si en sommeil momentane *)
                        save   : boolean; (* space save? *)
                        Lg     : word; (* only if save = true *)
                        case word of
                          FALSE : (point : pointer);
                          TRUE  : (Ofs,Seg : word);
                             (* adr de la sauvegarde du champ *)
                      end;
     Ref_spc   = array[1..2000] of Spc_map;

     Block_map = record
                   LgLigne   : byte;
                   MxNbSpc   : byte;
                   OutH,OutB,OutG,OutD : byte; (* dest sortie haute *)
                   InH, InB, InG, InD  : byte; (* dest entree basse *)
                   NbSpc     : byte;
                   Spc       : ^Ref_spc;
                 end;

const MxNbBlk = 20;
var
     NbBlk     : byte;
     Block     : array[1..MxNbBlk] of Block_map;

const
     BOUCLE = 0;
     BUTTE  = 255;
     COnSpc : byte = $70;
     CInUse : byte = $0E;

var (* reserve pour INTERACTION *)
    SelectSpc     : byte;    (* 1 *)
    SelectBlk     : byte;    (* 1 *)
    SelectSpace   : byte;    (* 1 *)
    SelectStat    : byte;    (* 1 *)
    ConstantOut   : boolean; (* 1 *)
    IntNormal     : boolean; (* 1 *)
    BaseInter     : byte absolute SelectSPC; (* pointe sur le debut *)

procedure DelSaveSpc(NumBlk,num : byte);
procedure DelAllSaveSpc(NumBlk : byte);
procedure CreateBlock(What : Block_map);
procedure OneBlock(LgLigne,MxNbSpc : byte;
                   BoucleHoriz,BoucleVerti : boolean);
procedure KillBlock;
procedure KillAllBlock;
procedure ResetSpc(NumBlk,num : byte);
procedure SaveSpc(NumBlk,num : byte);
procedure InitBlk;
procedure ChsSpc(NumBlk,NumSpace :byte);
function SearchSpc(NumBlk,Num : byte) : byte;
function GiveSpaceChut(NumSpace : byte) : boolean;
procedure SpaceChut(NumSpace : byte; What : boolean);
procedure EmpileBlk;
procedure DepileBlk;
procedure SpcAspect(NumBlk,num,Att : byte);
procedure SpaceOff;
procedure CurAspect(start,top : byte);

var  Key            : char;
     Funct          : boolean;
     CTRL           : byte;

procedure ViewKey;
procedure GetKey;
function Interaction : boolean;
procedure OpenInteraction(var pointspace; Longspace : word );
procedure CloseInteraction;

implementation (* ------------------------------------ *)

var Reg : registers;

(************** Variable de champs ***************)
type
     Ref_Space = array[1..2000] of Space_map;

var
     Space     : ^Ref_Space;
     MxLgSpace : byte;


const
      SizeOfspace = 6; (* longueur du block var interaction *)

procedure DelSaveSpc(Numblk,num : byte);
begin
  if Block[Numblk].Spc^[num].save then
    begin
      Block[NumBlk].Spc^[num].save := false;
      FreeMem(Block[NumBlk].Spc^[num].point,Block[NumBlk].Spc^[num].Lg);
    end;
end;

procedure DelAllSaveSpc(NumBlk : byte);
var index : byte;
begin
  for index := 1 to Block[NumBlk].NbSpc do DelSaveSpc(NumBlk,index);
end;

procedure CreateBlock(What : Block_map);
begin
  if NbBlk<MxNbBlk then
    begin
      Inc(NbBlk);
      Block[NbBlk] := What;
      Block[NbBlk].NbSpc := 0;
      GetMem(Block[NbBlk].Spc,Block[NbBlk].MxNbSpc*SizeOf(Spc_map));
    end;
end;

procedure OneBlock(LgLigne,MxNbSpc : byte;
                   BoucleHoriz,BoucleVerti : boolean);
(* cree un block isole *)
var Block : Block_map;
begin
  FillChar(Block,SizeOf(Block_map),0);
  Block.LgLigne := LgLigne;
  Block.MxNbSpc := MxNbSpc;
  if not(BoucleVerti) then
    begin
      Block.OutH := BUTTE;
      Block.OutB := BUTTE;
    end;
  if not(BoucleHoriz) then
    begin
      Block.OutG := BUTTE;
      Block.OutD := BUTTE;
    end;
  CreateBlock(Block);
end;

procedure KillBlock;
begin
  if NbBlk>0 then
    begin
      DelAllSaveSpc(NbBlk);
      FreeMem(Block[NbBlk].Spc,Block[NbBlk].MxNbSpc*SizeOf(Spc_map));
      Dec(NbBlk);
    end;
end;

procedure KillAllBlock;
begin
  while NbBlk>0 do KillBlock;
end;

procedure ResetSpc(numBlk,num : byte);
var index,jindex : byte;
    NumSpace     : byte;
    line         : array[1..80] of line_map;
begin
  if Block[numBlk].Spc^[num].save then
    begin
      NumSpace := Block[numBlk].Spc^[num].Space;
      for index:=0 to (Space^[NumSpace].Ht-1) do
        begin
          move(Mem[SegMemVideo:OfsMemVideo+(Space^[NumSpace].X shl 1)+
               (Space^[NumSpace].Y+index)*160],
               line[Space^[NumSpace].X+1].car,
               Space^[NumSpace].Lg shl 1);
          move(mem[Block[numBlk].Spc^[num].seg:Block[numBlk].Spc^[num].ofs+
               (index*Space^[NumSpace].Lg) shl 1],
               ScrLine[Space^[NumSpace].X+1].car,
               Space^[NumSpace].Lg shl 1);
          for jindex:=Space^[NumSpace].X+1 to
                      Space^[NumSpace].X+Space^[NumSpace].Lg do
            ScrLine[jindex].car := line[jindex].car;
         PutScrField(Space^[NumSpace].X,
                     Space^[NumSpace].Y+index,
                     Space^[NumSpace].Lg);
       end;
     Block[numBlk].Spc^[num].save := false;
     FreeMem(Block[numBlk].Spc^[num].point,Block[numBlk].Spc^[num].Lg);
   end;
end;

procedure SaveSpc(numBlk,num : byte);
var long     : word;
    index    : byte;
    NumSpace : byte;
begin
  if not(Block[numBlk].Spc^[num].save) then
    begin
      Block[numBlk].Spc^[num].save := true;
      NumSpace := Block[numBlk].Spc^[num].Space;
      long := (Space^[NumSpace].Lg*Space^[NumSpace].Ht) shl 1;
      GetMem(Block[numBlk].Spc^[num].point,long);
      Block[numBlk].Spc^[num].Lg := long;
      for index:=0 to (Space^[NumSpace].Ht-1) do
        begin
          move(mem[SegMemVideo:OfsMemVideo+(Space^[NumSpace].X shl 1)+
               (Space^[NumSpace].Y+index)*160],
               mem[Block[numBlk].Spc^[num].seg:Block[numBlk].Spc^[num].ofs+
               (index*Space^[NumSpace].Lg) shl 1],
               Space^[NumSpace].Lg shl 1);
        end;
    end;
end;

(******************** PILE Spc *******************)

type Blkpile_map = record
                     NbBlk   : byte;
                     Lg      : word;
                     case word of
                       FALSE : (point : pointer);
                       TRUE  : (Ofs,Seg : word);
                   end;
const MxLgBlkPile   = 20; (* 20 niveaux de pile pour les champs *)
var   BlkPile : array[1..MxLgBlkPile] of Blkpile_map;
      LgBlkPile : byte;

procedure InitBlk;
begin
  NbBlk := 0; (* aucun block cree *)
  SelectSPC := 0;
  SelectStat := 0; (* indique champs non allume *)
  ConstantOut := false;
  IntNormal := true;
end;

procedure ChsSpc(NumBlk,NumSpace :byte);
begin
  if Block[NumBlk].NbSpc<Block[NumBlk].MxNbSpc then
    begin
      Inc(Block[NumBlk].NbSpc);
      Block[NumBlk].Spc^[Block[NumBlk].NbSpc].Space := NumSpace;
      Block[NumBlk].Spc^[Block[NumBlk].NbSpc].save := false;
      Block[NumBlk].Spc^[Block[NumBlk].NbSpc].chut := false;
    end
end;

function SearchSpc(NumBlk,Num : byte) : byte;
var index : byte;
begin
  for index := 1 to Block[NumBlk].NbSpc do
    if Block[NumBlk].Spc^[index].Space = Num then
      begin
        SearchSpc := index;
        exit;
      end;
  SearchSpc := 0; (* pas trouve *)
end;

function GiveSpaceChut(NumSpace : byte) : boolean;
var SpcEcran : byte;
    index : byte;
begin
  for index := 1 to NbBlk do
    begin
      SpcEcran := SearchSpc(index,NumSpace);
      if SpcEcran<>0 then
        begin
          GiveSpaceChut := Block[index].Spc^[SpcEcran].chut;
          exit;
        end;
    end;
end;

procedure SpaceChut(NumSpace : byte; What : boolean);
var SpcEcran : byte;
    index    : byte;
begin
  for index := 1 to NbBlk do
    begin
      SpcEcran := SearchSpc(index,NumSpace);
      if SpcEcran<>0 then
        begin
          Block[index].Spc^[SpcEcran].chut := What;
          exit;
        end;
    end;
end;

procedure EmpileBlk;
var Lg : word;
    index : byte;
begin
  if LgBlkPile<MxLgBlkPile then
    begin
      Inc(LgBlkPile);
      BlkPile[LgBlkPile].NbBlk := NbBlk;
      Lg := SizeOfSpace+SizeOf(Block_map)*NbBlk;
      BlkPile[LgBlkPile].Lg := Lg;
      GetMem(BlkPile[LgBlkPile].point,Lg);
      (* on sauvegarde d'abord l'en tete-interaction *)
      move(BaseInter,BlkPile[LgBlkPile].point^,SizeOfSpace);
      (* on sauvegarde les NbBlk de taille variable *)
      Lg := SizeOfSpace;
      for index := 1 to NbBlk do
        begin
          move(Block[index],
               mem[BlkPile[LgBlkPile].seg:
                   BlkPile[LgBlkPile].ofs+Lg],
               SizeOf(Block_map) );
          Inc(Lg,SizeOf(Block_map));
        end;
      InitBlk;
    end;
end;

procedure DepileBlk;
var Lg : word;
    index : byte;
begin
  if LgBlkPile>0 then
    begin
      KillAllBlock; (* on vide la memoire avant de quitter ! *)
      NbBlk := BlkPile[LgBlkPile].NbBlk;
      move(BlkPile[LgBlkPile].point^,BaseInter,SizeOfSpace);
      Lg := SizeOfSpace;
      for index := 1 to NbBlk do
        begin
          move(mem[BlkPile[LgBlkPile].seg:
                   BlkPile[LgBlkPile].ofs+Lg],
               Block[index],
               SizeOf(Block_map) );
          Inc(Lg,SizeOf(Block_map));
        end;
      FreeMem(BlkPile[LgBlkPile].point,BlkPile[LgBlkPile].Lg);
      Dec(LgBlkPile);
    end;
end;

(********************* INTERACTION ***********************)

procedure SpcAspect(NumBlk,num,Att : byte);
var NumSpace : byte;
begin
  NumSpace := Block[NumBlk].Spc^[num].Space;
  WindAspect(Space^[NumSpace].X,Space^[NumSpace].Y,
             Space^[NumSpace].X+(Space^[NumSpace].Lg-1),
             Space^[NumSpace].Y+(Space^[NumSpace].Ht-1),
             Att);
end;

(******************* CLAVIER ****************)

procedure ViewKey;
begin
  if keypressed then
    begin
      reg.ax := $0200;
      intr($16,reg);
      CTRL := reg.al;
      key := ReadKey;
      if key=#0 then
        begin
          key := ReadKey;
          Funct := true;
        end
      else
        Funct := false;
    end
  else Key := #0;
end;

procedure GetKey;
begin
  repeat
    ViewKey;
  until Key<>#0;
end;

function FirstSpc(NumBlk : byte) : byte;
var index : byte;
begin
  for index := 1 to Block[NumBlk].NbSpc do
    if not(Block[NumBlk].Spc^[index].chut) then
      begin
        FirstSpc := index;
        exit;
      end;
  FirstSpc := 0; (* entraine une erreur!! *)
end;

function LastSpc(NumBlk : byte) : byte;
var index : byte;
begin
  for index := Block[NumBlk].NbSpc Downto 1 do
    if not(Block[NumBlk].Spc^[index].chut) then
      begin
        LastSpc := index;
        exit;
      end;
  LastSpc := 0; (* retourne une valeur hors norme *)
end;

procedure SpaceOff;
begin
  if SelectStat<>0 then
    begin
      ResetSpc(SelectBlk,SelectSpc);
      SelectStat := 0;
    end;
end;

procedure ShowSpc;
begin
  if SelectStat=0 then
    begin
      SelectStat := 1;
      SaveSpc(SelectBlk,SelectSpc);
      SpcAspect(SelectBlk,SelectSpc,COnSpc);
    end;
end;

var ResultBlk,ResultSpc : byte;
    (* variable consultable que si on a trouve quelque chose! *)

function FindSpcH(NmBlk,NmSpc : ShortInt) : boolean;
begin
  if (NmBlk<=0) or (NmBlk>NbBlk) or (NmSpc>Block[NmBlk].NbSpc) then
    FindSpcH := false
  else
    begin
      while (NmSpc>0) do
        if Block[NmBlk].Spc^[NmSpc].chut then
          Dec(NmSpc,Block[NmBlk].LgLigne)
        else
          begin
            FindSpcH := true;
            ResultBlk := NmBlk;
            ResultSpc := NmSpc;
            exit;
          end;
      FindSpcH := false;
    end;
end;

function FindBlkH(NmBlk : ShortInt) : boolean;
var NmSpc : ShortInt;
begin
  while (NmBlk>0) and (NmBlk<=NbBlk) do
    begin
      NmSpc := Block[NmBlk].InB;
      if FindSpcH(NmBlk,NmSpc) then
        begin
          FindBlkH := true;
          exit;
        end
      else
        NmBlk := Block[NmBlk].OutH;
    end;
  FindBlkH := false;
end;

procedure LineSup(var BsBlk,BsSpc : byte); (* les valeurs doivent etre juste! *)
(* recherche du champs superieur au present *)
(* boucle infinie si aucun champs n'est trouve! *)
var NmBlk,NmSpc : ShortInt;
begin
  NmBlk := BsBlk;
  NmSpc := BsSpc;
  repeat
    Dec(NmSpc,Block[NmBlk].LgLigne);
    if NmSpc<=0 then (* tentative de sortie de block ? *)
      if Block[NmBlk].OutH=BOUCLE then (* on boucle *)
        NmSpc := Block[NmBlk].NbSpc+(NmSpc mod Block[NmBlk].LgLigne)
      else
        if Block[NmBlk].OutH=BUTTE then
          NmSpc := BsSpc (* on butte *)
        else
          if FindBlkH(Block[NmBlk].OutH) then
            begin
              NmBlk := ResultBlk;
              NmSpc := ResultSpc;
            end
          else
            NmSpc := BsSpc; (* on butte *)
  until not(Block[NmBlk].Spc^[NmSpc].chut);
  (* ici, NmSpc et NmBlk contiennent les bonnes valeurs *)
  BsBlk := NmBlk;
  BsSpc := NmSpc;
end;

function FindSpcB(NmBlk,NmSpc : ShortInt) : boolean;
begin
  if (NmBlk<=0) or (NmBlk>NbBlk) or (NmSpc<=0) then
    FindSpcB := false
  else
    begin
      while (NmSpc<=Block[NmBlk].NbSpc) do
        if Block[NmBlk].Spc^[NmSpc].chut then
          Inc(NmSpc,Block[NmBlk].LgLigne)
        else
          begin
            FindSpcB := true;
            ResultBlk := NmBlk;
            ResultSpc := NmSpc;
            exit;
          end;
      FindSpcB := false;
    end;
end;

function FindBlkB(NmBlk : ShortInt) : boolean;
var NmSpc : ShortInt;
begin
  while (NmBlk>0) and (NmBlk<=NbBlk) do
    begin
      NmSpc := Block[NmBlk].InH;
      if FindSpcB(NmBlk,NmSpc) then
        begin
          FindBlkB := true;
          exit;
        end
      else
        NmBlk := Block[NmBlk].OutB;
    end;
  FindBlkB := false;
end;

procedure LineInf(var BsBlk,BsSpc : byte); (* les valeurs doivent etre juste! *)
(* recherche du champs superieur au present *)
(* boucle infinie si aucun champs n'est trouve! *)
var NmBlk,NmSpc : ShortInt;
begin
  NmBlk := BsBlk;
  NmSpc := BsSpc;
  repeat
    Inc(NmSpc,Block[NmBlk].LgLigne);
    if NmSpc>Block[NmBlk].NbSpc then (* tentative de sortie de block ? *)
      if Block[NmBlk].OutB=BOUCLE then (* on boucle *)
        NmSpc := abs((NmSpc-1) mod Block[NmBlk].LgLigne)+1
      else
        if Block[NmBlk].OutB=BUTTE then
          NmSpc := BsSpc (* on butte *)
        else
          if FindBlkB(Block[NmBlk].OutB) then
            begin
              NmBlk := ResultBlk;
              NmSpc := ResultSpc;
            end
          else
            NmSpc := BsSpc; (* on butte *)
  until not(Block[NmBlk].Spc^[NmSpc].chut);
  (* ici, NmSpc et NmBlk contiennent les bonnes valeurs *)
  BsBlk := NmBlk;
  BsSpc := NmSpc;
end;

function FindSpcG(NmBlk,NmSpc : ShortInt) : boolean;
begin
  if (NmBlk<=0) or (NmBlk>NbBlk) or (NmSpc>Block[NmBlk].NbSpc) then
    FindSpcG := false
  else
    begin
      while ((NmSpc Mod Block[NmBlk].LgLigne)<>0) do
        if Block[NmBlk].Spc^[NmSpc].chut then Dec(NmSpc)
        else
          begin
            FindSpcG := true;
            ResultBlk := NmBlk;
            ResultSpc := NmSpc;
            exit;
          end;
      FindSpcG := false;
    end;
end;

function FindBlkG(NmBlk : ShortInt) : boolean;
var NmSpc : ShortInt;
begin
  while (NmBlk>0) and (NmBlk<=NbBlk) do
    begin
      NmSpc := Block[NmBlk].InD;
      if FindSpcH(NmBlk,NmSpc) then
        begin
          FindBlkG := true;
          exit;
        end
      else
        NmBlk := Block[NmBlk].OutG;
    end;
  FindBlkG := false;
end;

procedure ColGauche(var BsBlk,BsSpc : byte);
var NmBlk,NmSpc : ShortInt;
begin
  NmBlk := BsBlk;
  NmSpc := BsSpc;
  repeat
    Dec(NmSpc);
    if (NmSpc Mod Block[NmBlk].LgLigne)=0 then
      (* tentative de sortie de block ? *)
      if Block[NmBlk].OutG=BOUCLE then
        begin (* on boucle *)
          NmSpc := NmSpc+Block[NmBlk].LgLigne;
          if NmSpc>Block[NmBlk].NbSpc then
            NmSpc := Block[NmBlk].NbSpc;
        end
      else
        if Block[NmBlk].OutG=BUTTE then
          NmSpc := BsSpc (* on butte *)
        else
          if FindBlkG(Block[NmBlk].OutG) then
            begin
              NmBlk := ResultBlk;
              NmSpc := ResultSpc;
            end
          else
            NmSpc := BsSpc; (* on butte *)
  until not(Block[NmBlk].Spc^[NmSpc].chut);
  (* ici, NmSpc et NmBlk contiennent les bonnes valeurs *)
  BsBlk := NmBlk;
  BsSpc := NmSpc;
end;

function FindSpcD(NmBlk,NmSpc : ShortInt) : boolean;
begin
  if (NmBlk<=0) or (NmBlk>NbBlk) or (NmSpc>Block[NmBlk].NbSpc) then
    FindSpcD := false
  else
    begin
      repeat
        if Block[NmBlk].Spc^[NmSpc].chut then Inc(NmSpc)
        else
          begin
            FindSpcD := true;
            ResultBlk := NmBlk;
            ResultSpc := NmSpc;
            exit;
          end;
      until (((NmSpc-1) mod Block[NmBlk].LgLigne)=0);
      FindSpcD := false;
    end;
end;

function FindBlkD(NmBlk : ShortInt) : boolean;
var NmSpc : ShortInt;
begin
  while (NmBlk>0) and (NmBlk<=NbBlk) do
    begin
      NmSpc := Block[NmBlk].InG;
      if FindSpcD(NmBlk,NmSpc) then
        begin
          FindBlkD := true;
          exit;
        end
      else
        NmBlk := Block[NmBlk].OutD;
    end;
  FindBlkD := false;
end;

procedure ColDroite(var BsBlk,BsSpc : byte);
var NmBlk,NmSpc : ShortInt;
begin
  NmBlk := BsBlk;
  NmSpc := BsSpc;
  repeat
    Inc(NmSpc);
    if ((NmSpc-1) mod Block[NmBlk].LgLigne)=0 then
      (* tentative de sortie de block ? *)
      if Block[NmBlk].OutD=BOUCLE then
        begin (* on boucle *)
          NmSpc := NmSpc-Block[NmBlk].LgLigne;
          if NmSpc<=0 then NmSpc := 1;
        end
      else
        if Block[NmBlk].OutD=BUTTE then
          NmSpc := BsSpc (* on butte *)
        else
          if FindBlkD(Block[NmBlk].OutD) then
            begin
              NmBlk := ResultBlk;
              NmSpc := ResultSpc;
            end
          else
            NmSpc := BsSpc; (* on butte *)
  until not(Block[NmBlk].Spc^[NmSpc].chut);
  (* ici, NmSpc et NmBlk contiennent les bonnes valeurs *)
  BsBlk := NmBlk;
  BsSpc := NmSpc;
end;

function Interaction : boolean;
(* pour fonctionner, il faut au moins un Spc disponible dans un Blk *)
(* En sortie, Interaction indique si la cause de la sortie est *)
(* dut a la selection d'un champs par SPACE BARRE *)
(* TRUE  -> Key=0 et un champs est en selection par SPACE BARRE *)
(* FALSE -> Key<>#0  ce qui est la cause de la sortie! *)

begin
  if IntNormal then
    begin
      if (SelectSpc=0) then
        if NbBlk<>0 then
          begin (* on initialise car il s'agit *)
                (* du premier acces a interaction *)
            SelectStat := 0;
            SelectBlk := 1;
            SelectSpc := FirstSpc(SelectBlk);
          end
        else
          begin
            interaction := false; (* incident!! *)
            key := #0;
          end
      else
        if SelectStat=2 then
          begin
            SpcAspect(SelectBlk,SelectSpc,COnSpc);
            SelectStat := 1;
          end;
      ShowSpc;
    end
  else
    IntNormal := true;
  repeat
    ViewKey;
    if Key<>#0 then
      if not(Funct) then
        begin
          if (Key = ' ') or (Key=#13) then
            begin (* selection *)
              (* SelectSpc et SelectBlk porte l'information *)
              SpcAspect(SelectBlk,SelectSpc,CInUse);
              SelectSpace := Block[SelectBlk].Spc^[SelectSpc].space;
              SelectStat := 2;
              Interaction := true;
              exit;
            end
          else
            begin
              Interaction := false;
              exit;
            end;
        end
      else
        begin
          case Key of
            #71 : begin (* Home *)
                    SpaceOff;
                    SelectSpc := FirstSpc(SelectBlk); (* premier champs *)
                  end;
            #79 : begin (* End *)
                    SpaceOff;
                    SelectSpc := LastSpc(SelectBlk);
                      (* dernier champs *)
                  end;
            #72 : (* ligne superieur *)
                  begin
                    SpaceOff;
                    LineSup(SelectBlk,SelectSpc);
                  end;
            #80 : begin (* ligne inferieur *)
                    SpaceOff;
                    LineInf(SelectBlk,SelectSpc);
                  end;
            #75 : begin (* vers gauche *)
                    SpaceOff;
                    ColGauche(SelectBlk,SelectSpc);
                  end;
            #77 : begin (* vers droite *)
                    SpaceOff;
                    ColDroite(SelectBlk,SelectSpc);
                  end;
            #73 : begin (* PgUp *)
                    SpaceOff;
                    if FindBlkH(Block[SelectBlk].OutH) then
                      begin
                        SelectBlk := ResultBlk;
                        SelectSpc := FirstSpc(SelectBlk);
                      end;
                  end;
            #81 : begin (* PgDn *)
                    SpaceOff;
                    if FindBlkB(Block[SelectBlk].OutB) then
                      begin
                        SelectBlk := ResultBlk;
                        SelectSpc := FirstSpc(SelectBlk);
                      end;
                  end;
          else
            begin
              Interaction := false;
              exit;
            end;
          end; (* case of *)
          ShowSpc;
        end;
  until ConstantOut;
  IntNormal := false;
end;

procedure CurAspect(start,top : byte);
var rg : registers;
begin
  rg.AH := 1;
  rg.CH := start;
  rg.CL := top;
  intr($10,rg);
end;

procedure OpenInteraction(var pointSpace; LongSpace : word );
begin
  Space := @pointSpace;
  MxLgSpace := LongSpace;
  InitBlk;
  LgBlkPile := 0;
end;

procedure CloseInteraction;
begin
  while(LgBlkPile>0) do DepileBlk;
  KillAllBlock; (* vide dernier niveau *)
end;

begin
  LgBlkPile := 0;
  NbBlk := 0;
end.
