{$IFDEF VER40 }

  {$R-,S-,I-,D+,T-,F-,V-,B-,N-,L- }
  {$M 16384,0,655360 }

{$ELSE }

  {$A-,B-,D+,E-,F-,I-,L+,N-,O-,R-,S-,V- }
  {$M 16384,0,655360 }

{$ENDIF }

Unit RSSYS;

interface
uses Dos,Crt,Stringer,VideoSys,SerTools;

var Key   : char;
    Funct : boolean;
    CTRL  : byte;

const OneSec  = 18; (* la valeur juste est 18.2 *)
      FiveSec = 91; (* nombre de pulsation *)
      TenSec  = 182;
      OneMin  = 1092;

      TooLate    = -1; (* temps de sommeil atteind *)
      NoMoreTime = -2; (* temps global atteind *)
      UserAction = -3; (* touche presse (UserKey et UserFunct = touche) *)
      PassRelay  = -4; (* partage d'activite (Multitache) *)
      TrieCode   = -5; (* code filtrer (CurrentData = code) *)

      CRien  = $00;
      CNorm  = $07;
      CSurI  = $0F;
      CInv   = $70;

type Flag_map = record
                  X,Y  : byte;
                  All  : boolean;
                  Dep  : LongInt;
                  Lim  : word;
                end;
const FlagIn         = 1;
      FlagSoftFilter = 2;
      FlagHardFilter = 3;
      FlagPartage    = 4;
      FlagOut        = 5;
      FlagModem      = 6;
      FlagLine       = 10;

var Flag : array[1..13] of Flag_map;
    Xdd,Ydd : byte;
    LgDiodes : byte;
    LastStDiodes1 : ShortInt;
    LastStDiodes2 : ShortInt;

procedure CLI; inline($FA);
procedure STI; inline($FB);

function NbPulse : LongInt;

const LgStringPath = 20;
type StringPath = string[LgStringPath];

var SleepTime     : LongInt; (* temps de sommeil maximun *)
    GlobalTime    : LongInt; (* temps de global maximun *)
    DualActivity  : boolean; (* flags commandant les sortie regulieres *)
       (* FALSE -> normal Multitache = FALSE *)
       (* TRUE  -> GetData retourne parfois -4 Multitache = TRUE *)
       (*          FindPath retourne -4 et Multitache = TRUE *)
    UserKey       : char;
    UserFunct     : boolean;
    CurrentData   : ShortInt; (* dernier code passe par GetData *)
                              (* Utile pour TrieCode *)
    Multitache    : boolean; (* indique que la 'main' est a RsSys *)
                             (* et donc situation anormale *)
    InitSleepTime : boolean; (* normalement, son etat est l'inverse de *)
                             (* Multitache. il commande l'initialisation *)
                             (* de l'horloge interne de GetData          *)
                             (* sort toujours a TRUE sauf si Multitache=FALSE *)
    Buffer        : StringPath; (* FindPath *)
    PathResult    : StringPath; (* FindPath *)
    OrgGlobalTime : LongInt;    (* FindPath *)
    OrgSleepTime  : LongInt;    (* GetData  *)
    EmulIn        : boolean;    (* GetData : si l'on emul les entree *)
    EmulOut       : boolean;    (* PutData : si l'on emul les sortie *)
    EmulLineDeb   : boolean; (* si on emule le passage a la ligne suivante *)

procedure SetFlag(num : byte; all : boolean);
procedure SetFlagModem(St : byte);
procedure SetFlagLine(St : byte);
procedure SetFlagCom;
procedure SetFlagDiodes1(St : ShortInt);
procedure SetFlagDiodes2(St : ShortInt);

(* EMUL-M6 *)

const LgPCode = 9;
var Xm6,Ym6 : ShortInt;
    XWindM6,YWindM6,LgWindM6,HtWindM6 : byte;
    Aig : byte;
            (* 0 : aucun aiguillage *)
            (* 1 : ESC              *)
    EcRouleau : boolean;
    Param1,Param2,Param3 : byte;
    PCode : array[0..LgPCode] of byte;
    AttM6 : byte; (* attribut direct a l'ecran *)
    LastAttM6 : byte;
    LastXm6,LastYm6 : shortInt;

procedure MakeCadre(Xhaut,Yhaut,Xbas,Ybas,coul : byte);
procedure CurChange;
procedure RectifXY;
procedure ResetWindM6;
procedure EmulM6(data : byte);

(* SEEK-PATH *)

procedure SetFilter(var point1; Lg1 : byte; var point2; lg2 : byte;
                    var point3; Lg3 : byte);
procedure PutData(data : ShortInt);
function GetData : ShortInt;
function FindPath(var point; LgTab : byte) : ShortInt;
function GetPath(texte : string) : ShortInt;
function GetDoublePath(Path1,Path2 : string) : ShortInt;
procedure InitBuffer;
procedure InitRsSys;
procedure OpenRsSys(x,y,Lg,Ht : byte);
procedure CloseRsSys;

implementation (**************)

procedure ViewKey;
var reg : registers;
begin
  if keypressed then
    begin
      reg.ax := $0200;
      intr($16,reg);
      CTRL := reg.al;
      key := ReadKey;
      if key=#0 then
        begin
          key := ReadKey;
          Funct := true;
        end
      else
        Funct := false;
    end
  else Key := #0;
end;

procedure GetKey;
begin
  repeat
    ViewKey;
  until Key<>#0;
end;


procedure MakeCadre(Xhaut,Yhaut,Xbas,Ybas,coul : byte);
var buf_texte : string;
    index : byte;
begin
  buf_texte := FillString(Xbas-(Xhaut+1),196);
  WriteScr(buf_texte,coul,Xhaut+1,Yhaut);
  WriteScr(buf_texte,coul,Xhaut+1,Ybas);
  for index:=Yhaut+1 to Ybas-1 do
    begin
      WrtByte(179,coul,Xhaut,index);
      WrtByte(179,coul,Xbas,index);
    end;
  WrtByte(218,coul,Xhaut,Yhaut);
  WrtByte(191,coul,Xbas,Yhaut);
  WrtByte(217,coul,Xbas,Ybas);
  WrtByte(192,coul,Xhaut,Ybas);
end;


(****)

(** --- **)

const Bit : array[0..7] of byte = (1,2,4,8,16,32,64,128);

(***************** EMULM6 ******************)

(*$L TIMERKIT.OBJ *)

var IndexPulse : LongInt;

procedure IntPulse; external;

function NbPulse : longint;
begin
  CLI;
  NbPulse := IndexPulse;
  STI;
end;

procedure CurChange;
begin
  GotoXY(XWindM6+Xm6+1,YWindM6+Ym6+1);
end;

procedure RectifXY;
begin
  if Xm6<0 then Xm6 := 0
  else
    if Xm6>=LgWindM6 then Xm6 := LgWindM6-1;
  if Ym6<0 then Ym6 := 0
  else
    if Ym6>=HtWindM6 then Ym6 := HtWindM6-1;
end;

procedure EmptyLineM6(ligne,Xstart,Limite : byte);
begin
  WriteScr(FillString((limite+1)-Xstart,32),CNorm,
           XWindM6+XStart,YWindM6+ligne);
end;

procedure NextLine;
begin
  Inc(Ym6);
  if Ym6>=HtWindM6 then
    if EcRouleau then
      begin
        Ym6 := HtWindM6-1;
        EmpileWind(XWindM6,YWindM6+1,XWindM6+LgWindM6-1,YWindM6+HtWindM6-1);
        DepileWindTo(XWindM6,YWindM6);
        EmptyLineM6(Ym6,0,LgWindM6-1);
      end
    else Ym6 := 0;
  CurChange;
end;

procedure PrecLine;
begin
  Dec(Ym6);
  if Ym6<0 then
    if EcRouleau then
      begin
        Ym6 := 0;
        EmpileWind(XWindM6,YWindM6,XWindM6+LgWindM6-1,YWindM6+HtWindM6-2);
        DepileWindTo(XWindM6,YWindM6+1);
        EmptyLineM6(Ym6,0,LgWindM6-1);
      end
    else Ym6 := HtWindM6-1;
  CurChange;
end;

procedure ClrScrM6(ligne,Lim : byte);
var index : byte;
begin
  for index := ligne to lim do EmptyLineM6(index,0,LgWindM6-1);
end;

procedure ResetWindM6;
begin
  Xm6 := 0;
  Ym6 := 0;
  Aig := 0;
  AttM6 := CNorm;
  EcRouleau := true;
  LastXm6 := Xm6;
  LastYm6 := Ym6;
  LastAttM6 := AttM6;
  ClrScrM6(0,HtWindM6-1);
  CurChange;
end;

procedure EmulM6(data : byte);
begin
  if (data=0) or (data>127) then exit;
  if data<32 then
    begin
      if Aig<>0 then Aig := 0; (* interruption d'aiguillage *)
      case Data of
        08 : begin (* curseur vers gauche *)
               Dec(Xm6);
               if Xm6<0 then Xm6 := 0;
               CurChange;
             end;
        09 : begin (* curseur +8 vers la droite *)
               Inc(Xm6,8);
               if Xm6>=LgWindM6 then Xm6 := LgWindM6-1;
               CurChange;
             end;
        10,11,12 : NextLine; (* ligne en bas *)
        13 : begin
               Xm6 := 0;
               CurChange;
             end;
        24,26 : begin
                  WrtByte(178,CNorm,Xm6+XWindM6,Ym6+YWindM6);
                  Inc(Xm6);
                  if Xm6>=LgWindM6 then Xm6 := LgWindM6-1;
                  CurChange;
                end;
        27 : Aig := 1;
      end;
    end
  else
    begin (* alph ou ESC et param *)
      case Aig of
        0 : begin
              WrtByte(data,AttM6,Xm6+XWindM6,Ym6+YWindM6);
              Inc(Xm6);
              if Xm6>=LgWindM6 then
                if EmulLineDeb then
                  begin
                    Xm6 := 0;
                    NextLine;
                  end
                else Xm6 := LgWindM6-1;
              CurChange;
            end;
        1 : begin (* ESC X [,Y...] *)
              case Data of
                32..47 : begin (* ISO 2022 *)
                           Aig    := 2;
                           Param1 := 0;
                           Param2 := Data; (* on garde l'information *)
                         end;
                53..54 : Aig := 3;
                55 : begin (* memorise contexte *)
                       LastAttM6 := AttM6;
                       LastXm6 := Xm6;
                       LastYm6 := Ym6;
                     end;
                56 : begin (* restitue contexte *)
                       AttM6 := LastAttM6;
                       Xm6 := LastXm6;
                       Ym6 := LastYm6;
                       RectifXY;
                       CurChange;
                     end;
                57..59 : begin
                           Aig := 4+(Data-57); (* Aig=4,5,6 *)
                           Param3 := 0;
                         end;
                68 : NextLine; (* Esc D -> LF *)
                69 : begin
                       NextLine;
                       Xm6 := 0;
                       CurChange;
                     end;
                77 : PrecLine; (* Esc M -> ligne precedente *)
                91 : begin (* CSI *)
                       Aig := 7;
                       Param1 := 0;
                       Param2 := 0;
                       Param3 := 0;
                     end;
                99 : ResetWindM6; (* Esc c : reset *)
              end; (* case of *)
              if Aig=1 then Aig:=0;
            end;
        2 : begin (*  ISO 2022 *)
              (* Param2 = premier code apres ESC *)
              (* on filtre tout *)
              if data>=48 then Aig := 0; (* top-final *)
            end;
        3 : Aig := 0;
        4 : Aig := 0; (* PRO1 *)
        5 : (* PRO2 *)
            if Param3=0 then
              begin
                Param1 := Data;
                Param3 := 1;
              end
            else
              begin
                Param2 := Data;
                (* l'analyse porte sur Param1 et Param2 *)
                case Param2 of
                  67 : (* Ecran *)
                       case Param1 of
                         105 : EcRouleau := true; (* ecran rouleau *)
                         106 : EcRouleau := false; (* ecran page *)
                       end; (* case of *)
                end; (* case of *)
                Aig := 0;
              end;
        6 : begin (* PRO3 : on filtre *)
              Inc(Param3);
              if Param3>=3 then Aig := 0;
            end;
   7 : begin (* ISO 6429 :  CSI, 3/x...3/z, 2/x...2/z,(64..127) *)
         (* Param1 = Parametre en cours d'estimation (0..64) *)
         (* Param2 = Numero Parametre (0..LongCode) *)
         (* Param3 = etat analyse 0:ok  Autres:2/x...2/z detecte! *)
         (* Attention : 2/x...2/z annule l'action *)
         if Data in [48..57] then
           begin
             if Param1<4 then Param1 := Param1*10+(Data-48)
             else Param1 := 40; (* signifie le debordement *)
           end
         else
           if Data = 59 then
             begin (* separateur de parametre detecte *)
               PCode[Param2] := Param1;
               Param1 := 0;
               if Param2<LgPCode then Param2 := Param2+1;
             end
           else
             if Data>=64 then
               begin (* le top-final de la commande est arrive *)
                 if Param3=0 then (* pas de syntaxe error *)
                   begin
                     PCode[Param2]:=Param1;
    (* PCode[0..Param2] = parametres *)
    (* il y a obligatoirement 1 parametre ('0' minimun *)
  case char(Data) of
    'A'..'D' : begin (* curseur move *)
       Param1 := PCode[0]; (* le 1' param compte *)
       if Param1=0 then Param1 := 1; (* Param1 = nbre de decalage curseur *)
       case char(Data) of
         'A' : Dec(Ym6,Param1);
         'B' : Inc(Ym6,Param1);
         'C' : Inc(Xm6,Param1);
         'D' : Dec(Xm6,Param1);
       end;
       RectifXY;
       CurChange;
               end;

     'J' : begin (* effacement niveau ecran *)
       Param1 := PCode[0]; (* le 1' param interesse *)
       (* Param1 = type d'effacement *)
       case Param1 of
         0 : begin (* clr du cur inclus a la fin de l'ecran *)
               EmptyLineM6(Ym6,Xm6,LgWindM6-1);
               ClrScrM6(Ym6+1,HtWindM6-1);
             end;
         1 : begin (* clr du debut ecran a cur inclus *)
               ClrScrM6(0,Ym6-1);
               EmptyLineM6(Ym6,0,Xm6);
             end;
         2 : begin (* clr de tout l'ecran , cur inchange *)
               ClrScrM6(0,HtWindM6-1);
             end;
       end;
           end;

     'K' : begin (* effacement au niveau d'une ligne *)
       Param1 := PCode[0]; (* le premier code compte *)
       (* Param1 = type de clr *)
       case Param1 of
         0 : begin (* clr du cur inclus a la fin de ligne *)
               EmptyLineM6(Ym6,Xm6,LgWindM6-1);
             end;
         1 : begin (* clr du debut de ligne au cur inclus *)
               EmptyLineM6(Ym6,0,Xm6);
             end;
         2 : begin (* clr la ligne , cur inchange *)
               EmptyLineM6(Ym6,0,LgWindM6-1);
             end;
       end;
           end;

     'H' : begin (* adressage direct curseur *)

      if Param2=0 then PCode[1] := 0; (* second parametre non-initialise *)
       Xm6 := PCode[1];
       Ym6 := PCode[0];
       if Xm6>0 then Dec(Xm6);
       if Ym6>0 then Dec(Ym6);
       RectifXY;
       CurChange;
           end;
     'm' : begin (* attribut *)
             Param1 := PCode[0];
             case Param1 of
               0 : AttM6 := CNorm;
               1 : AttM6 := AttM6 or 8; (* sur i *)
               5 : AttM6 := AttM6 or 128; (* cli *)
               7 : AttM6 := (AttM6 and (255-7)) or 112; (* RVS *)
               22 : AttM6 := (AttM6 and (255-8)); (* i normal *)
               25 : AttM6 := (AttM6 and 127); (* non cli *)
               27 : AttM6 := (AttM6 and (255-112)) or 7; (* fond normal *)
             end; (* case of *)
           end;
  end; (* case of *)
                   end; (* Param3=0 *)
                Aig := 0;
               end  (* data>=64 *)
             else Param3 := 1; (* indic analyse anormale *)
         end; (* ISO 6429 *)
      end; (* case of *)
  end; (* begin *)
end;

(*************** SEEKPATH ***************)

type Filter_map = array[1..128,1..2] of byte;
var
    LgHardFilt : byte;        (* longueur *)
    HardFilt   : ^Filter_map; (* totalement ignore *)
    LgSoftFilt : byte;        (* longueur *)
    SoftFilt   : ^Filter_map; (* non restitue mais initialise le temps *)
    LgTrieFilt : byte;
    TrieFilt   : ^Filter_map; (* sort en -5 et le code est dans *)
                              (* LastCodeDetect *)

procedure SetFilter(var point1; Lg1 : byte; var point2; lg2 : byte;
                    var point3; Lg3 : byte);
begin
  HardFilt   := @point1;
  LgHardFilt := Lg1;
  SoftFilt   := @point2;
  LgSoftFilt := Lg2;
  TrieFilt   := @point3;
  LgTrieFilt := Lg3;
end;

procedure AffFlag(x,y : byte; all : boolean);
var coul : byte;
begin
  if all then
    begin
      WrtByte(220,CsurI,x,y-1);
      WrtByte(223,CsurI,x,y);
    end
  else
    begin
      WrtByte(196,CNorm,x,y-1);
      WrtByte(196,CNorm,x,y);
    end
end;

procedure SetFlag(num : byte; all : boolean);
begin
  if all then
    begin
      Flag[num].Dep := NbPulse;
      if not(Flag[num].All) then
        begin
          AffFlag(Flag[num].X,Flag[num].Y,true);
          Flag[num].All := true;
        end;
    end
  else
    if Flag[num].All then
      if (NbPulse-Flag[num].Dep)>Flag[num].Lim then
        begin
          AffFlag(Flag[num].X,Flag[num].Y,false);
          Flag[num].All := false;
        end;
end;

procedure SetFlagModem(St : byte);
var index : byte;
begin
  St := St shr 4;
  for index := 0 to 3 do
    SetFlag((3-index)+FlagModem,(St and bit[index])<>0);
end;

procedure SetFlagLine(St : byte);
var index : byte;
begin
  St := St shr 1;
  for index := 0 to 3 do
    SetFlag((3-index)+FlagLine,(St and bit[index])<>0);
end;

procedure SetFlagDiodes1(St : ShortInt);
var index : ShortInt;
begin
  if St<0 then St := 0
  else
    if St>LgDiodes then St := LgDiodes;
  if St<LastStDiodes1 then
    begin
      for index := LastStDiodes1-1 Downto St do
        WrtByte(196,CNorm,Xdd+index,Ydd);
    end
  else
    if St>LastStDiodes1 then
      begin
        for index := LastStDiodes1 to St-1 do
          WrtByte(223,CsurI,Xdd+index,Ydd);
      end;
  LastStDiodes1 := St;
end;

procedure SetFlagDiodes2(St : ShortInt);
var index : ShortInt;
begin
  if St<0 then St := 0
  else
    if St>LgDiodes then St := LgDiodes;
  if St<LastStDiodes2 then
    begin
      for index := LastStDiodes2-1 Downto St do
        WrtByte(196,CNorm,Xdd+index,Ydd-1);
    end
  else
    if St>LastStDiodes2 then
      begin
        for index := LastStDiodes2 to St-1 do
          WrtByte(220,CsurI,Xdd+index,Ydd-1);
      end;
  LastStDiodes2 := St;
end;

procedure SetFlagCom;
begin
  SetFlagModem(StModem);
  SetFlagLine(StLine);
end;

procedure PutData(data : ShortInt);
(* envoi un code sur la rs en la declarant comme flag emission *)
begin
  if data>=0 then
    begin
      SetFlag(FlagOut,true);
      PutCom(char(data));
      if EmulOut then EmulM6(data);
    end
  else SetFlag(FlagOut,false);
  SetFlagCom;
end;

function HardFilter(data : ShortInt) : boolean;
var index : byte;
begin
  for index := 1 to LgHardFilt do
    if (data>=HardFilt^[index,1]) and (data<=HardFilt^[index,2]) then
      begin
        HardFilter := true;
        exit;
      end;
  HardFilter := false;
end;

function SoftFilter(data : ShortInt) : boolean;
var index : byte;
begin
  for index := 1 to LgSoftFilt do
    if (data>=SoftFilt^[index,1]) and (data<=SoftFilt^[index,2]) then
      begin
        SoftFilter := true;
        exit;
      end;
  SoftFilter := false;
end;

function TrieFilter(data : ShortInt) : boolean;
var index : byte;
begin
  for index := 1 to LgTrieFilt do
    if (data>=TrieFilt^[index,1]) and (data<=TrieFilt^[index,2]) then
      begin
        TrieFilter := true;
        exit;
      end;
  TrieFilter := false;
end;

function GetData : ShortInt;
(* en sortie 255 -> temps sommeil atteind -1 TooLate    *)
(*           254 -> temps global  atteind -2 NoMoreTime *)
(*           253 -> Action utilisateur    -3 UserAction *)
(*           252 -> sortie force          -4 Multitache *)
(*           251 -> Filtrage special      -5 TrieCode   *)
var Code     : ShortInt;
    EndBoucle : boolean;
begin
  if InitSleepTime then OrgSleepTime := NbPulse
  else InitSleepTime := true;
  if Multitache then Multitache    := false;
  (* donc ici: InitSleepTime=true  Multitache=false *)
  EndBoucle := false;
  repeat
    if (NbPulse-OrgGlobalTime)>GlobalTime then
      begin
        EndBoucle := true;
        Code := NoMoreTime; (* -2 , #254 *)
        SetFlagDiodes2(0);
      end
    else
      begin
        SetFlagDiodes2((LgDiodes)-(((NbPulse-OrgGlobalTime)*LgDiodes) div GlobalTime));
        if (NbPulse-OrgSleepTime)>SleepTime then
          begin
            EndBoucle := true;
            Code := TooLate; (* -1 , 255 *)
            SetFlagDiodes1(0);
          end
        else
          begin
            SetFlagDiodes1((LgDiodes)-(((NbPulse-OrgSleepTime)*LgDiodes) div SleepTime));
            if CharIn then
              begin
                SetFlag(FlagIn,true);
                Code := ShortInt(GetCom);
                CurrentData := Code;
                if HardFilter(Code) then SetFlag(FlagHardFilter,true)
                else
                  begin
                    SetFlag(FlagHardFilter,false);
                    if SoftFilter(Code) then
                      begin
                        OrgSleepTime := NbPulse;
                        SetFlagDiodes1(LgDiodes);
                        SetFlag(FlagSoftFilter,true)
                      end
                    else
                      begin
                        EndBoucle := true;
                        SetFlag(FlagSoftFilter,false);
                        if EmulIn then EmulM6(byte(Code));
                        if TrieFilter(Code) then Code := TrieCode;
                          (* on sort avec TrieCode (-5)   *)
                          (* le code est dans CurrentData *)
                      end;
                  end;
              end
            else
              begin
                SetFlag(FlagIn,false);
                SetFlag(FlagHardFilter,false);
                SetFlag(FlagSoftFilter,false);
                if UserKey<>#0 then
                  begin
                    ViewKey;
                    if ((Key=UserKey) and (Funct=UserFunct)) or
                       ((Key<>#0) and (UserKey=#255)) then
                      begin
                        EndBoucle := true;
                        Code := UserAction; (* -3 , 253 *)
                      end;
                  end;
              end;
          end;
      end;
    SetFlagCom;
    SetFlag(FlagPartage,false);
    SetFlag(FlagOut,false);
  until EndBoucle or DualActivity;
  if not(EndBoucle) then
    begin (* sortie contrainte *)
      code          := PassRelay; (* -4 , 252 *)
      Multitache    := true;
      InitSleepTime := false;
      SetFlag(FlagPartage,true);
    end;
  GetData := Code;
end;

function CompEgal(Base,This : StringPath) : boolean;
var index : byte;
    car   : char;
begin
  for index := 1 to length(This) do
    if This[index]=#255 then This[index] := Base[index]
    else
      if (This[index]<>Base[index]) or (Base[index]=#255) then
        begin
          CompEgal := false;
          exit;
        end;
  PathResult := This;
  CompEgal := true;
end;

function FindPath(var point; LgTab : byte) : ShortInt;
var Tab : array[1..50] of StringPath absolute point;
    info   : shortInt;
    code   : shortInt;
    index  : byte;
begin
  PathResult := '';
  code := 0;
  if LgTab>0 then
    begin
      if not(Multitache) then
        begin
          index := 1;
          while (index<=LgTab) and (code=0) do
            if Tab[index][0]=#0 then code:=index
            else Inc(index);
        end;
      if code=0 then
        begin
          if not(Multitache) then
            OrgGlobalTime := NbPulse; (* garde le temps de depart *)
          repeat
            info := GetData;
            if info<0 then code := info
            else
              begin
                move(Buffer[2],Buffer[1],LgStringPath-1);
                Buffer[LgStringPath] := char(info);
                index := 1;
                while (index<=LgTab) do
                  begin
  if CompEgal(
       copy(Buffer,(LgStringPath+1)-length(tab[index]),length(tab[index])),
       Tab[index]) then
         begin
           code := index;
           index := LgTab;
         end;
                    Inc(index);
                  end;
              end;
          until code<>0;
        end;
    end;
  FindPath := code; (* FindPath->0 si tableau nul *)
end;

function GetPath(texte : string) : ShortInt;
begin
  GetPath := FindPath(texte,1);
end;

function GetDoublePath(Path1,Path2 : string) : ShortInt;
var Tab : array[1..2] of StringPath;
begin
  Tab[1] := Path1;
  Tab[2] := Path2;
  GetDoublePath := FindPath(Tab,2);
end;

(******************************)

var SaveIntVec    : pointer;

procedure InitBuffer;
(* on bufferise avec le code 255 *)
(* ce code indique une information non altere *)
begin
  FillChar(Buffer,SizeOf(Buffer),255);
  Buffer[0] := char(SizeOf(Buffer)-1); (* le buffer est initialise *)
end;

procedure InitRsSys;
begin
  SleepTime  := TenSec*3;
  GlobalTime := OneMin*3;
  DualActivity := false; (* pas de sortie force *)
  UserKey := #0;
  UserFunct := false;

  CurrentData := 0;
  Multitache := false;
  InitSleepTime := true;

  PathResult := '';
  OrgGlobalTime := 0;
  OrgSleepTime  := 0;
  LgHardFilt := 0;
  LgSoftFilt := 0;
  LgTrieFilt := 0;
end;

procedure OpenRsSys(x,y,Lg,Ht : byte);
const Pos = 30;
  procedure InitFlag(numDep,NbFlag,Xdep,Y,DefTm : byte);
  var index : byte;
  begin
    for index := numDep to numDep+NbFlag-1 do
      begin
        Flag[index].X := Xdep+(index-numDep)*2;
        Flag[index].Y := Y;
        Flag[index].All := false;
        Flag[index].Lim := DefTm;
      end;
  end;
begin
  ClrZone(X,Y+1,X+Lg-1,Y+Ht-2,CNorm); (* desswind *)
  MakeCadre(X,Y+1,X+Lg-1,Y+Ht-2,CNorm);
  WriteScr('ĿĿĿĿ',CNorm,X,Y);
  WriteScr('',CNorm,X,Y+1);
  (* etat monitor *)
  InitFlag(FlagIn,3,X+1,Y+1,3);
  Flag[FlagIn].Lim := 1; (* reception *)
  (* beep *)
  (* wait *)
  InitFlag(FlagPartage,2,X+8,Y+1,1); (* double travaux *)
  (* etat du modem *)
  InitFlag(FlagModem,4,X+13,Y+1,3);
  (* pret a emettre *)
  (* Modem pret *)
  (* sonnerie *)
  (* connexion etablie *)
  (* etat de ligne *)
  InitFlag(FlagLine,4,X+24,Y+1,9);
  WrtByte(byte(''),CNorm,X+Pos,Y);
  WrtByte(byte(''),CNorm,X+Pos,Y+1);
  WriteScr(FillString(Lg-(Pos+2),196),CNorm,X+(Pos+1),Y);
  WrtByte(byte(''),CNorm,X+Lg-1,Y);
  WrtByte(byte(''),CNorm,X+Lg-1,Y+1);
  LgDiodes := Lg-(Pos+2);
  LastStDiodes1 := 0;
  LastStDiodes2 := 0;
  Xdd := X+Pos+1;
  Ydd := Y+1;
  XWindM6 := x+1;
  YWindM6 := y+2;
  LgWindM6 := Lg-2;
  HtWindM6 := Ht-4;
  ResetWindM6;

  IndexPulse := 0;
  GetIntVec($1C,SaveIntVec);
  SetIntVec($1C,@IntPulse);

  EmulIn  := true;
  EmulOut := false;
  EmulLineDeb := false;

  InitBuffer;
  InitRsSys;
end;

procedure CloseRsSys;
begin
  SetIntVec($1C,SaveIntVec);
end;

end.
